/***************************************************************************
 *
 *            Copyright (c) 2006 by CMX Systems, Inc.
 *
 * This software is copyrighted by and is the sole property of
 * CMX.  All rights, title, ownership, or other interests
 * in the software remain the property of CMX.  This
 * software may only be used in accordance with the corresponding
 * license agreement.  Any unauthorized use, duplication, transmission,
 * distribution, or disclosure of this software is expressly forbidden.
 *
 * This Copyright notice may not be removed or modified without prior
 * written consent of CMX.
 *
 * CMX reserves the right to modify this software without notice.
 *
 * CMX Systems, Inc.
 * 12276 San Jose Blvd. #511
 * Jacksonville, FL 32223
 * USA
 *
 * Tel:  (904) 880-1840
 * Fax:  (904) 880-1632
 * http: www.cmx.com
 * email: cmx@cmx.com
 *
 ***************************************************************************/
#ifndef _MCF5222X_REGS_H_
#define _MCF5222X_REGS_H_

#include "hcc_types.h"

/* 
 * Memory map definitions from linker command files 
 */
extern hcc_u8 _IPSBAR[];
extern hcc_u32 _SRAM[];

/* 
 * Memory Map Info 
 */
#define IPSBAR_ADDRESS			(hcc_u32)_IPSBAR

#define SRAM_ADDRESS			(hcc_u32)_SRAM

#define BITX(x) (1U<<##x)
#define BIT0	BITX(0)
#define BIT1	BITX(1)
#define BIT2	BITX(2)
#define BIT3	BITX(3)
#define BIT4	BITX(4)
#define BIT5	BITX(5)
#define BIT6	BITX(6)
#define BIT7 	BITX(7)
#define BIT8	BITX(8)
#define BIT9	BITX(9)
#define BIT10   BITX(10)
#define BIT11	BITX(11)
#define BIT12   BITX(12)
#define BIT13	BITX(13)
#define BIT14   BITX(14)
#define BIT15	BITX(15)
#define BIT16   BITX(16)
#define BIT17	BITX(17)
#define BIT18   BITX(18)
#define BIT19	BITX(19)
#define BIT20   BITX(20)
#define BIT21	BITX(21)
#define BIT22   BITX(22)
#define BIT23	BITX(23)
#define BIT24   BITX(24)
#define BIT25	BITX(25)
#define BIT26   BITX(26)
#define BIT27	BITX(27)
#define BIT28   BITX(28)
#define BIT29	BITX(29)
#define BIT30   BITX(30)
#define BIT31	BITX(31)

/*********************************************************************
*
* Core register bit definitions
*
*********************************************************************/
/* Status Register */
#define MCF5XXX_SR_T        (0x8000)
#define MCF5XXX_SR_S        (0x2000)
#define MCF5XXX_SR_M        (0x1000)
#define MCF5XXX_SR_IPL      (0x0700)
#define MCF5XXX_SR_IPL_0    (0x0000)
#define MCF5XXX_SR_IPL_1    (0x0100)
#define MCF5XXX_SR_IPL_2    (0x0200)
#define MCF5XXX_SR_IPL_3    (0x0300)
#define MCF5XXX_SR_IPL_4    (0x0400)
#define MCF5XXX_SR_IPL_5    (0x0500)
#define MCF5XXX_SR_IPL_6    (0x0600)
#define MCF5XXX_SR_IPL_7    (0x0700)
#define MCF5XXX_SR_X        (0x0010)
#define MCF5XXX_SR_N        (0x0008)
#define MCF5XXX_SR_Z        (0x0004)
#define MCF5XXX_SR_V        (0x0002)
#define MCF5XXX_SR_C        (0x0001)

/* Cache Control Register */
#define MCF5XXX_CACR_CENB       (0x80000000)
#define MCF5XXX_CACR_DEC        (0x80000000)
#define MCF5XXX_CACR_DW         (0x40000000)
#define MCF5XXX_CACR_DESB       (0x20000000)
#define MCF5XXX_CACR_CPDI       (0x10000000)
#define MCF5XXX_CACR_DDPI       (0x10000000)
#define MCF5XXX_CACR_CPD        (0x10000000)
#define MCF5XXX_CACR_CFRZ       (0x08000000)
#define MCF5XXX_CACR_DHLCK      (0x08000000)
#define MCF5XXX_CACR_DDCM_WT    (0x00000000)
#define MCF5XXX_CACR_DDCM_CB    (0x02000000)
#define MCF5XXX_CACR_DDCM_IP    (0x04000000)
#define MCF5XXX_CACR_DDCM_II    (0x06000000)
#define MCF5XXX_CACR_CINV       (0x01000000)
#define MCF5XXX_CACR_DCINVA     (0x01000000)
#define MCF5XXX_CACR_DIDI       (0x00800000)
#define MCF5XXX_CACR_DDSP       (0x00800000)
#define MCF5XXX_CACR_DISD       (0x00400000)
#define MCF5XXX_CACR_INVI       (0x00200000)
#define MCF5XXX_CACR_INVD       (0x00100000)
#define MCF5XXX_CACR_BEC        (0x00080000)
#define MCF5XXX_CACR_BCINVA     (0x00040000)
#define MCF5XXX_CACR_IEC        (0x00008000)
#define MCF5XXX_CACR_DNFB       (0x00002000)
#define MCF5XXX_CACR_IDPI       (0x00001000)
#define MCF5XXX_CACR_IHLCK      (0x00000800)
#define MCF5XXX_CACR_CEIB       (0x00000400)
#define MCF5XXX_CACR_IDCM       (0x00000400)
#define MCF5XXX_CACR_DCM_WR     (0x00000000)
#define MCF5XXX_CACR_DCM_CB     (0x00000100)
#define MCF5XXX_CACR_DCM_IP     (0x00000200)
#define MCF5XXX_CACR_DCM        (0x00000200)
#define MCF5XXX_CACR_DCM_II     (0x00000300)
#define MCF5XXX_CACR_DBWE       (0x00000100)
#define MCF5XXX_CACR_ICINVA     (0x00000100)
#define MCF5XXX_CACR_IDSP       (0x00000080)
#define MCF5XXX_CACR_DWP        (0x00000020)
#define MCF5XXX_CACR_EUSP       (0x00000020)
#define MCF5XXX_CACR_EUST       (0x00000020)
#define MCF5XXX_CACR_DF         (0x00000010)
#define MCF5XXX_CACR_CLNF_00    (0x00000000)
#define MCF5XXX_CACR_CLNF_01    (0x00000002)
#define MCF5XXX_CACR_CLNF_10    (0x00000004)
#define MCF5XXX_CACR_CLNF_11    (0x00000006)

/* Access Control Register */
#define MCF5XXX_ACR_AB(a)       ((a)&0xFF000000)
#define MCF5XXX_ACR_AM(a)       (((a)&0xFF000000) >> 8)
#define MCF5XXX_ACR_AM_4G       (0x00FF0000)
#define MCF5XXX_ACR_AM_2G       (0x007F0000)
#define MCF5XXX_ACR_AM_1G       (0x003F0000)
#define MCF5XXX_ACR_AM_1024M    (0x003F0000)
#define MCF5XXX_ACR_AM_512M     (0x001F0000)
#define MCF5XXX_ACR_AM_256M     (0x000F0000)
#define MCF5XXX_ACR_AM_128M     (0x00070000)
#define MCF5XXX_ACR_AM_64M      (0x00030000)
#define MCF5XXX_ACR_AM_32M      (0x00010000)
#define MCF5XXX_ACR_AM_16M      (0x00000000)
#define MCF5XXX_ACR_EN          (0x00008000)
#define MCF5XXX_ACR_SM_USER     (0x00000000)
#define MCF5XXX_ACR_SM_SUPER    (0x00002000)
#define MCF5XXX_ACR_SM_IGNORE   (0x00006000)
#define MCF5XXX_ACR_ENIB        (0x00000080)
#define MCF5XXX_ACR_CM          (0x00000040)
#define MCF5XXX_ACR_DCM_WR      (0x00000000)
#define MCF5XXX_ACR_DCM_CB      (0x00000020)
#define MCF5XXX_ACR_DCM_IP      (0x00000040)
#define MCF5XXX_ACR_DCM_II      (0x00000060)
#define MCF5XXX_ACR_CM          (0x00000040)
#define MCF5XXX_ACR_BWE         (0x00000020)
#define MCF5XXX_ACR_WP          (0x00000004)

/* RAM Base Address Register */
#define MCF5XXX_RAMBAR_BA(a)    ((a)&0xFFFFC000)
#define MCF5XXX_RAMBAR_PRI_00   (0x00000000)
#define MCF5XXX_RAMBAR_PRI_01   (0x00004000)
#define MCF5XXX_RAMBAR_PRI_10   (0x00008000)
#define MCF5XXX_RAMBAR_PRI_11   (0x0000C000)
#define MCF5XXX_RAMBAR_WP       (0x00000100)
#define MCF5XXX_RAMBAR_CI       (0x00000020)
#define MCF5XXX_RAMBAR_SC       (0x00000010)
#define MCF5XXX_RAMBAR_SD       (0x00000008)
#define MCF5XXX_RAMBAR_UC       (0x00000004)
#define MCF5XXX_RAMBAR_UD       (0x00000002)
#define MCF5XXX_RAMBAR_V        (0x00000001)

/*********************************************************************
*
* System Control Module (SCM)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_SCM_IPSBAR               (*(hcc_reg32*)(&_IPSBAR[0x000000]))
#define MCF_SCM_RAMBAR               (*(hcc_reg32*)(&_IPSBAR[0x000008]))
#define MCF_SCM_CRSR                 (*(hcc_reg8 *)(&_IPSBAR[0x000010]))
#define MCF_SCM_CWCR                 (*(hcc_reg8 *)(&_IPSBAR[0x000011]))
#define MCF_SCM_LPICR                (*(hcc_reg8 *)(&_IPSBAR[0x000012]))
#define MCF_SCM_CWSR                 (*(hcc_reg8 *)(&_IPSBAR[0x000013]))
#define MCF_SCM_PPMRH                (*(hcc_reg32*)(&_IPSBAR[0x00000C]))
#define MCF_SCM_PPMRL                (*(hcc_reg32*)(&_IPSBAR[0x000018]))
#define MCF_SCM_PPMRS                (*(hcc_reg8 *)(&_IPSBAR[0x000021]))
#define MCF_SCM_PPMRC                (*(hcc_reg8 *)(&_IPSBAR[0x000022]))

/* Bit definitions and macros for MCF_SCM_IPSBAR */
#define MCF_SCM_IPSBAR_V             (0x00000001)
#define MCF_SCM_IPSBAR_BA(x)         ((x)&0xC0000000)

/* Bit definitions and macros for MCF_SCM_RAMBAR */
#define MCF_SCM_RAMBAR_BDE           (0x00000200)
#define MCF_SCM_RAMBAR_BA(x)         ((x)&0xFFFF0000)

/* Bit definitions and macros for MCF_SCM_CRSR */
#define MCF_SCM_CRSR_CWDR            (0x20)
#define MCF_SCM_CRSR_EXT             (0x80)

/* Bit definitions and macros for MCF_SCM_CWCR */
#define MCF_SCM_CWCR_CWTIC           (0x01)
#define MCF_SCM_CWCR_CWTAVAL         (0x02)
#define MCF_SCM_CWCR_CWTA            (0x04)
#define MCF_SCM_CWCR_CWT(x)          (((x)&0x07)<<3)
#define MCF_SCM_CWCR_CWRI            (0x40)
#define MCF_SCM_CWCR_CWE             (0x80)

/* Bit definitions and macros for MCF_SCM_LPICR */
#define MCF_SCM_LPICR_XIPL(x)        (((x)&0x07)<<4)
#define MCF_SCM_LPICR_ENBSTOP        (0x80)

/* Bit definitions and macros for MCF_SCM_CWSR */
#define MCF_SCM_CWSR_CWSR(x)         (((x)&0xFF)<<0)

/* Bit definitions and macros for MCF_SCM_PPMRH */
#define MCF_SCM_PPMRH_CDPORTS        (0x00000001)
#define MCF_SCM_PPMRH_CDEPORT        (0x00000002)
#define MCF_SCM_PPMRH_CDPIT0         (0x00000008)
#define MCF_SCM_PPMRH_CDPIT1         (0x00000010)
#define MCF_SCM_PPMRH_CDADC          (0x00000080)
#define MCF_SCM_PPMRH_CDGPT          (0x00000100)
#define MCF_SCM_PPMRH_CDPWN          (0x00000200)
#define MCF_SCM_PPMRH_CDFCAN         (0x00000400)
#define MCF_SCM_PPMRH_CDCFM          (0x00000800)

/* Bit definitions and macros for MCF_SCM_PPMRL */
#define MCF_SCM_PPMRL_CDG            (0x00000002)
#define MCF_SCM_PPMRL_CDEIM          (0x00000008)
#define MCF_SCM_PPMRL_CDDMA          (0x00000010)
#define MCF_SCM_PPMRL_CDUART0        (0x00000020)
#define MCF_SCM_PPMRL_CDUART1        (0x00000040)
#define MCF_SCM_PPMRL_CDUART2        (0x00000080)
#define MCF_SCM_PPMRL_CDI2C          (0x00000200)
#define MCF_SCM_PPMRL_CDQSPI         (0x00000400)
#define MCF_SCM_PPMRL_CDDTIM0        (0x00002000)
#define MCF_SCM_PPMRL_CDDTIM1        (0x00004000)
#define MCF_SCM_PPMRL_CDDTIM2        (0x00008000)
#define MCF_SCM_PPMRL_CDDTIM3        (0x00010000)
#define MCF_SCM_PPMRL_CDINTC0        (0x00020000)

/* Bit definitions and macros for MCF_SCM_PPMRS */
#define MCF_SCM_PPMRS_DISABLE_ALL    (64)
#define MCF_SCM_PPMRS_DISABLE_CFM    (43)
#define MCF_SCM_PPMRS_DISABLE_CAN    (42)
#define MCF_SCM_PPMRS_DISABLE_PWM    (41)
#define MCF_SCM_PPMRS_DISABLE_GPT    (40)
#define MCF_SCM_PPMRS_DISABLE_ADC    (39)
#define MCF_SCM_PPMRS_DISABLE_PIT1   (36)
#define MCF_SCM_PPMRS_DISABLE_PIT0   (35)
#define MCF_SCM_PPMRS_DISABLE_EPORT  (33)
#define MCF_SCM_PPMRS_DISABLE_PORTS  (32)
#define MCF_SCM_PPMRS_DISABLE_INTC   (17)
#define MCF_SCM_PPMRS_DISABLE_DTIM3  (16)
#define MCF_SCM_PPMRS_DISABLE_DTIM2  (15)
#define MCF_SCM_PPMRS_DISABLE_DTIM1  (14)
#define MCF_SCM_PPMRS_DISABLE_DTIM0  (13)
#define MCF_SCM_PPMRS_DISABLE_QSPI   (10)
#define MCF_SCM_PPMRS_DISABLE_I2C    (9)
#define MCF_SCM_PPMRS_DISABLE_UART2  (7)
#define MCF_SCM_PPMRS_DISABLE_UART1  (6)
#define MCF_SCM_PPMRS_DISABLE_UART0  (5)
#define MCF_SCM_PPMRS_DISABLE_DMA    (4)
#define MCF_SCM_PPMRS_SET_CDG        (1)

/* Bit definitions and macros for MCF_SCM_PPMRC */
#define MCF_SCM_PPMRC_ENABLE_ALL     (64)
#define MCF_SCM_PPMRC_ENABLE_CFM     (43)
#define MCF_SCM_PPMRC_ENABLE_CAN     (42)
#define MCF_SCM_PPMRC_ENABLE_PWM     (41)
#define MCF_SCM_PPMRC_ENABLE_GPT     (40)
#define MCF_SCM_PPMRC_ENABLE_ADC     (39)
#define MCF_SCM_PPMRC_ENABLE_PIT1    (36)
#define MCF_SCM_PPMRC_ENABLE_PIT0    (35)
#define MCF_SCM_PPMRC_ENABLE_EPORT   (33)
#define MCF_SCM_PPMRC_ENABLE_PORTS   (32)
#define MCF_SCM_PPMRC_ENABLE_INTC    (17)
#define MCF_SCM_PPMRC_ENABLE_DTIM3   (16)
#define MCF_SCM_PPMRC_ENABLE_DTIM2   (15)
#define MCF_SCM_PPMRC_ENABLE_DTIM1   (14)
#define MCF_SCM_PPMRC_ENABLE_DTIM0   (13)
#define MCF_SCM_PPMRC_ENABLE_QSPI    (10)
#define MCF_SCM_PPMRC_ENABLE_I2C     (9)
#define MCF_SCM_PPMRC_ENABLE_UART2   (7)
#define MCF_SCM_PPMRC_ENABLE_UART1   (6)
#define MCF_SCM_PPMRC_ENABLE_UART0   (5)
#define MCF_SCM_PPMRC_ENABLE_DMA     (4)
#define MCF_SCM_PPMRC_CLEAR_CDG      (1)

/*********************************************************************
*
* Clock Module (CLOCK)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_CLOCK_SYNCR           (*(hcc_reg16*)(&_IPSBAR[0x120000]))
#define MCF_CLOCK_SYNSR           (*(hcc_reg8 *)(&_IPSBAR[0x120002]))
#define MCF_CLOCK_LPCR            (*(hcc_reg8 *)(&_IPSBAR[0x120007]))
#define MCF_CLOCK_CCHR            (*(hcc_reg8 *)(&_IPSBAR[0x120008]))
#define MCF_CLOCK_RTCDR           (*(hcc_reg32*)(&_IPSBAR[0x12000C]))

/* Bit definitions and macros for MCF_CLOCK_SYNCR */
#define MCF_CLOCK_SYNCR_PLLEN     (0x0001)
#define MCF_CLOCK_SYNCR_PLLMODE   (0x0002)
#define MCF_CLOCK_SYNCR_CLKSRC    (0x0004)
#define MCF_CLOCK_SYNCR_FWKUP     (0x0020)
#define MCF_CLOCK_SYNCR_DISCLK    (0x0040)
#define MCF_CLOCK_SYNCR_LOCEN     (0x0080)
#define MCF_CLOCK_SYNCR_RFD(x)    (((x)&0x0007)<<8)
#define MCF_CLOCK_SYNCR_LOCRE     (0x0800)
#define MCF_CLOCK_SYNCR_MFD(x)    (((x)&0x0007)<<12)
#define MCF_CLOCK_SYNCR_LOLRE     (0x8000)

/* Bit definitions and macros for MCF_CLOCK_SYNSR */
#define MCF_CLOCK_SYNSR_LOCS      (0x04)
#define MCF_CLOCK_SYNSR_LOCK      (0x08)
#define MCF_CLOCK_SYNSR_LOCKS     (0x10)
#define MCF_CLOCK_SYNSR_CRYOSC    (0x20)
#define MCF_CLOCK_SYNSR_OCOSC     (0x40)
#define MCF_CLOCK_SYNSR_EXTOSC    (0x80)

/* Bit definitions and macros for MCF_CLOCK_LPCR */
#define MCF_CLOCK_LPCR_LPD(x)     (((x)&0x0F)<<0)

/* Bit definitions and macros for MCF_CLOCK_CCHR */
#define MCF_CLOCK_CCHR_PFD(x)     (((x)&0x07)<<0)

/* Bit definitions and macros for MCF_CLOCK_RTCDR */
#define MCF_CLOCK_RTCDR_RTCDF(x)  (((x)&0xFFFFFFFF)<<0)


/*********************************************************************
*
* Universal Serial Bus (USB)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_USB_PER_ID                       (*(hcc_reg8 *)(&_IPSBAR[0x1C0000]))
#define MCF_USB_IP_COMP                      (*(hcc_reg8 *)(&_IPSBAR[0x1C0004]))
#define MCF_USB_REV                          (*(hcc_reg8 *)(&_IPSBAR[0x1C0008]))
#define MCF_USB_ADD_INFO                     (*(hcc_reg8 *)(&_IPSBAR[0x1C000C]))
#define MCF_USB_OTG_INT_STAT                 (*(hcc_reg8 *)(&_IPSBAR[0x1C0010]))
#define MCF_USB_OTG_INT_EN                   (*(hcc_reg8 *)(&_IPSBAR[0x1C0014]))
#define MCF_USB_OTG_STATUS                   (*(hcc_reg8 *)(&_IPSBAR[0x1C0018]))
#define MCF_USB_OTG_CTRL                     (*(hcc_reg8 *)(&_IPSBAR[0x1C001C]))
#define MCF_USB_INT_STAT                     (*(hcc_reg8 *)(&_IPSBAR[0x1C0080]))
#define MCF_USB_INT_ENB                      (*(hcc_reg8 *)(&_IPSBAR[0x1C0084]))
#define MCF_USB_ERR_STAT                     (*(hcc_reg8 *)(&_IPSBAR[0x1C0088]))
#define MCF_USB_ERR_ENB                      (*(hcc_reg8 *)(&_IPSBAR[0x1C008C]))
#define MCF_USB_STAT                         (*(hcc_reg8 *)(&_IPSBAR[0x1C0090]))
#define MCF_USB_CTL                          (*(hcc_reg8 *)(&_IPSBAR[0x1C0094]))
#define MCF_USB_ADDR                         (*(hcc_reg8 *)(&_IPSBAR[0x1C0098]))
#define MCF_USB_BDT_PAGE_01                  (*(hcc_reg8 *)(&_IPSBAR[0x1C009C]))
#define MCF_USB_FRM_NUML                     (*(hcc_reg8 *)(&_IPSBAR[0x1C00A0]))
#define MCF_USB_FRM_NUMH                     (*(hcc_reg8 *)(&_IPSBAR[0x1C00A4]))
#define MCF_USB_FRM_NUM       (MCF_USB_INT_STAT=MCF_USB_INT_STAT_SOF_TOK ,MCF_USB_FRM_NUML | (((hcc_u16)MCF_USB_FRM_NUMH)<<8))
#define MCF_USB_TOKEN                        (*(hcc_reg8 *)(&_IPSBAR[0x1C00A8]))
#define MCF_USB_SOF_THLDL                    (*(hcc_reg8 *)(&_IPSBAR[0x1C00AC]))
#define MCF_USB_BDT_PAGE_02                  (*(hcc_reg8 *)(&_IPSBAR[0x1C00B0]))
#define MCF_USB_BDT_PAGE_03                  (*(hcc_reg8 *)(&_IPSBAR[0x1C00B4]))
#define MCF_USB_ENDPT0                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00C0]))
#define MCF_USB_ENDPT1                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00C4]))
#define MCF_USB_ENDPT2                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00C8]))
#define MCF_USB_ENDPT3                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00CC]))
#define MCF_USB_ENDPT4                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00D0]))
#define MCF_USB_ENDPT5                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00D4]))
#define MCF_USB_ENDPT6                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00D8]))
#define MCF_USB_ENDPT7                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00DC]))
#define MCF_USB_ENDPT8                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00E0]))
#define MCF_USB_ENDPT9                       (*(hcc_reg8 *)(&_IPSBAR[0x1C00E4]))
#define MCF_USB_ENDPT10                      (*(hcc_reg8 *)(&_IPSBAR[0x1C00E8]))
#define MCF_USB_ENDPT11                      (*(hcc_reg8 *)(&_IPSBAR[0x1C00EC]))
#define MCF_USB_ENDPT12                      (*(hcc_reg8 *)(&_IPSBAR[0x1C00F0]))
#define MCF_USB_ENDPT13                      (*(hcc_reg8 *)(&_IPSBAR[0x1C00F4]))
#define MCF_USB_ENDPT14                      (*(hcc_reg8 *)(&_IPSBAR[0x1C00F8]))
#define MCF_USB_ENDPT15                      (*(hcc_reg8 *)(&_IPSBAR[0x1C00FC]))
#define MCF_USB_USB_CTRL                     (*(hcc_reg8 *)(&_IPSBAR[0x1C0100]))
#define MCF_USB_USB_OTG_OBSERVE              (*(hcc_reg8 *)(&_IPSBAR[0x1C0104]))
#define MCF_USB_USB_OTG_CONTROL              (*(hcc_reg8 *)(&_IPSBAR[0x1C0108]))

/* Bit definitions and macros for MCF_USB_PER_ID */
#define MCF_USB_PER_ID_ID(x)                 (((x)&0x3F)<<0)

/* Bit definitions and macros for MCF_USB_IP_COMP */
#define MCF_USB_IP_COMP_NID(x)               (((x)&0x3F)<<0)

/* Bit definitions and macros for MCF_USB_REV */
#define MCF_USB_REV_REV(x)                   (((x)&0xFF)<<0)

/* Bit definitions and macros for MCF_USB_ADD_INFO */
#define MCF_USB_ADD_INFO_HOST                (0x01)
#define MCF_USB_ADD_INFO_IRQ_NUM(x)          (((x)&0x1F)<<3)

/* Bit definitions and macros for MCF_USB_OTG_INT_STAT */
#define MCF_USB_OTG_INT_STAT_A_VBUS_VLD_CHG  (0x01)
#define MCF_USB_OTG_INT_STAT_B_SESS_END_CHG  (0x04)
#define MCF_USB_OTG_INT_STAT_SESS_VLD_CHG    (0x08)
#define MCF_USB_OTG_INT_STAT_LINE_STATE      (0x20)
#define MCF_USB_OTG_INT_STAT_1_MSEC          (0x40)
#define MCF_USB_OTG_INT_STAT_ID_CHG          (0x80)

/* Bit definitions and macros for MCF_USB_OTG_INT_EN */
#define MCF_USB_OTG_INT_EN_A_VBUS_VLD_EN     (0x01)
#define MCF_USB_OTG_INT_EN_B_SESS_END_EN     (0x04)
#define MCF_USB_OTG_INT_EN_SESS_VLD_EN       (0x08)
#define MCF_USB_OTG_INT_EN_LINE_STATE        (0x20)
#define MCF_USB_OTG_INT_EN_1_MSEC_EN         (0x40)
#define MCF_USB_OTG_INT_EN_ID_EN             (0x80)

/* Bit definitions and macros for MCF_USB_OTG_STATUS */
#define MCF_USB_OTG_STATUS_A_VBUS_VLD        (0x01)
#define MCF_USB_OTG_STATUS_B_SESS_END        (0x04)
#define MCF_USB_OTG_STATUS_SESS_VLD          (0x08)
#define MCF_USB_OTG_STATUS_LINE_STATE        (0x20)
#define MCF_USB_OTG_STATUS_1_MSEC            (0x40)
#define MCF_USB_OTG_STATUS_ID                (0x80)

/* Bit definitions and macros for MCF_USB_OTG_CTRL */
#define MCF_USB_OTG_CTRL_VBUS_DSCHG          (0x01)
#define MCF_USB_OTG_CTRL_VBUS_CHG            (0x02)
#define MCF_USB_OTG_CTRL_OTG_EN              (0x04)
#define MCF_USB_OTG_CTRL_VBUS_ON             (0x08)
#define MCF_USB_OTG_CTRL_DM_LOW              (0x10)
#define MCF_USB_OTG_CTRL_DP_LOW              (0x20)
#define MCF_USB_OTG_CTRL_DM_HIGH             (0x40)
#define MCF_USB_OTG_CTRL_DP_HIGH             (0x80)

/* Bit definitions and macros for MCF_USB_INT_STAT */
#define MCF_USB_INT_STAT_USB_RST             (0x01)
#define MCF_USB_INT_STAT_ERROR               (0x02)
#define MCF_USB_INT_STAT_SOF_TOK             (0x04)
#define MCF_USB_INT_STAT_TOK_DNE             (0x08)
#define MCF_USB_INT_STAT_SLEEP               (0x10)
#define MCF_USB_INT_STAT_RESUME              (0x20)
#define MCF_USB_INT_STAT_ATTACH              (0x40)
#define MCF_USB_INT_STAT_STALL               (0x80)

/* Bit definitions and macros for MCF_USB_INT_ENB */
#define MCF_USB_INT_ENB_USB_RST              (0x01)
#define MCF_USB_INT_ENB_ERROR                (0x02)
#define MCF_USB_INT_ENB_SOF_TOK              (0x04)
#define MCF_USB_INT_ENB_TOK_DNE              (0x08)
#define MCF_USB_INT_ENB_SLEEP                (0x10)
#define MCF_USB_INT_ENB_RESUME               (0x20)
#define MCF_USB_INT_ENB_ATTACH               (0x40)
#define MCF_USB_INT_ENB_STALL                (0x80)

/* Bit definitions and macros for MCF_USB_ERR_STAT */
#define MCF_USB_ERR_STAT_PID_ERR             (0x01)
#define MCF_USB_ERR_STAT_CRC5_EOF            (0x02)
#define MCF_USB_ERR_STAT_CRC16               (0x04)
#define MCF_USB_ERR_STAT_DFN8                (0x08)
#define MCF_USB_ERR_STAT_BTO_ERR             (0x10)
#define MCF_USB_ERR_STAT_DMA_ERR             (0x20)
#define MCF_USB_ERR_STAT_BTS_ERR             (0x80)

/* Bit definitions and macros for MCF_USB_ERR_ENB */
#define MCF_USB_ERR_ENB_PID_ERR              (0x01)
#define MCF_USB_ERR_ENB_CRC5_EOF             (0x02)
#define MCF_USB_ERR_ENB_CRC16                (0x04)
#define MCF_USB_ERR_ENB_DFN8                 (0x08)
#define MCF_USB_ERR_ENB_BTO_ERR              (0x10)
#define MCF_USB_ERR_ENB_DMA_ERR              (0x20)
#define MCF_USB_ERR_ENB_BTS_ERR              (0x80)

/* Bit definitions and macros for MCF_USB_STAT */
#define MCF_USB_STAT_ODD                     (0x04)
#define MCF_USB_STAT_TX                      (0x08)
#define MCF_USB_STAT_ENDP(x)                 (((x)&0x0F)<<4)

/* Bit definitions and macros for MCF_USB_CTL */
#define MCF_USB_CTL_USB_EN_SOF_EN            (0x01)
#define MCF_USB_CTL_ODD_RST                  (0x02)
#define MCF_USB_CTL_RESUME                   (0x04)
#define MCF_USB_CTL_HOST_MODE_EN             (0x08)
#define MCF_USB_CTL_RESET                    (0x10)
#define MCF_USB_CTL_TXDSUSPEND_TOKBUSY       (0x20)
#define MCF_USB_CTL_SE0                      (0x40)
#define MCF_USB_CTL_JSTATE                   (0x80)

/* Bit definitions and macros for MCF_USB_ADDR */
#define MCF_USB_ADDR_ADDR(x)                 (((x)&0x7F)<<0)
#define MCF_USB_ADDR_LS_EN                   (0x80)

/* Bit definitions and macros for MCF_USB_BDT_PAGE_01 */
#define MCF_USB_BDT_PAGE_01_BDT_BA9          (0x02)
#define MCF_USB_BDT_PAGE_01_BDT_BA10         (0x04)
#define MCF_USB_BDT_PAGE_01_BDT_BA11         (0x08)
#define MCF_USB_BDT_PAGE_01_BDT_BA12         (0x10)
#define MCF_USB_BDT_PAGE_01_BDT_BA13         (0x20)
#define MCF_USB_BDT_PAGE_01_BDT_BA14         (0x40)
#define MCF_USB_BDT_PAGE_01_BDT_BA15         (0x80)

/* Bit definitions and macros for MCF_USB_FRM_NUM */
#define MCF_USB_FRM_NUM_FRM(x)               (((x)&0xFFFF)<<0)

/* Bit definitions and macros for MCF_USB_FRM_NUML */
#define MCF_USB_FRM_NUML_FRM0                (0x01)
#define MCF_USB_FRM_NUML_FRM1                (0x02)
#define MCF_USB_FRM_NUML_FRM2                (0x04)
#define MCF_USB_FRM_NUML_FRM3                (0x08)
#define MCF_USB_FRM_NUML_FRM4                (0x10)
#define MCF_USB_FRM_NUML_FRM5                (0x20)
#define MCF_USB_FRM_NUML_FRM6                (0x40)
#define MCF_USB_FRM_NUML_FRM7                (0x80)

/* Bit definitions and macros for MCF_USB_FRM_NUMH */
#define MCF_USB_FRM_NUMH_FRM8                (0x01)
#define MCF_USB_FRM_NUMH_FRM9                (0x02)
#define MCF_USB_FRM_NUMH_FRM10               (0x04)
#define MCF_USB_FRM_NUMH_FRM11               (0x08)
#define MCF_USB_FRM_NUMH_FRM12               (0x10)
#define MCF_USB_FRM_NUMH_FRM13               (0x20)
#define MCF_USB_FRM_NUMH_FRM14               (0x40)
#define MCF_USB_FRM_NUMH_FRM15               (0x80)

/* Bit definitions and macros for MCF_USB_TOKEN */
#define MCF_USB_TOKEN_TOKEN_ENDPT(x)         (((x)&0x0F)<<0)
#define MCF_USB_TOKEN_TOKEN_PID(x)           (((x)&0x0F)<<4)

/* Bit definitions and macros for MCF_USB_SOF_THLDL */
#define MCF_USB_SOF_THLDL_CNT(x)             (((x)&0xFF)<<0)

/* Bit definitions and macros for MCF_USB_BDT_PAGE_02 */
#define MCF_USB_BDT_PAGE_02_BDT_BA16         (0x01)
#define MCF_USB_BDT_PAGE_02_BDT_BA17         (0x02)
#define MCF_USB_BDT_PAGE_02_BDT_BA18         (0x04)
#define MCF_USB_BDT_PAGE_02_BDT_BA19         (0x08)
#define MCF_USB_BDT_PAGE_02_BDT_BA20         (0x10)
#define MCF_USB_BDT_PAGE_02_BDT_BA21         (0x20)
#define MCF_USB_BDT_PAGE_02_BDT_BA22         (0x40)
#define MCF_USB_BDT_PAGE_02_BDT_BA23         (0x80)

/* Bit definitions and macros for MCF_USB_BDT_PAGE_03 */
#define MCF_USB_BDT_PAGE_03_BDT_BA24         (0x01)
#define MCF_USB_BDT_PAGE_03_BDT_BA25         (0x02)
#define MCF_USB_BDT_PAGE_03_BDT_BA26         (0x04)
#define MCF_USB_BDT_PAGE_03_BDT_BA27         (0x08)
#define MCF_USB_BDT_PAGE_03_BDT_BA28         (0x10)
#define MCF_USB_BDT_PAGE_03_BDT_BA29         (0x20)
#define MCF_USB_BDT_PAGE_03_BDT_BA30         (0x40)
#define MCF_USB_BDT_PAGE_03_BDT_BA31         (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT0 */
#define MCF_USB_ENDPT0_EP_HSHK               (0x01)
#define MCF_USB_ENDPT0_EP_STALL              (0x02)
#define MCF_USB_ENDPT0_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT0_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT0_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT0_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT0_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT1 */
#define MCF_USB_ENDPT1_EP_HSHK               (0x01)
#define MCF_USB_ENDPT1_EP_STALL              (0x02)
#define MCF_USB_ENDPT1_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT1_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT1_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT1_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT1_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT2 */
#define MCF_USB_ENDPT2_EP_HSHK               (0x01)
#define MCF_USB_ENDPT2_EP_STALL              (0x02)
#define MCF_USB_ENDPT2_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT2_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT2_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT2_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT2_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT3 */
#define MCF_USB_ENDPT3_EP_HSHK               (0x01)
#define MCF_USB_ENDPT3_EP_STALL              (0x02)
#define MCF_USB_ENDPT3_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT3_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT3_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT3_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT3_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT4 */
#define MCF_USB_ENDPT4_EP_HSHK               (0x01)
#define MCF_USB_ENDPT4_EP_STALL              (0x02)
#define MCF_USB_ENDPT4_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT4_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT4_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT4_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT4_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT5 */
#define MCF_USB_ENDPT5_EP_HSHK               (0x01)
#define MCF_USB_ENDPT5_EP_STALL              (0x02)
#define MCF_USB_ENDPT5_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT5_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT5_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT5_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT5_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT6 */
#define MCF_USB_ENDPT6_EP_HSHK               (0x01)
#define MCF_USB_ENDPT6_EP_STALL              (0x02)
#define MCF_USB_ENDPT6_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT6_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT6_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT6_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT6_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT7 */
#define MCF_USB_ENDPT7_EP_HSHK               (0x01)
#define MCF_USB_ENDPT7_EP_STALL              (0x02)
#define MCF_USB_ENDPT7_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT7_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT7_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT7_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT7_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT8 */
#define MCF_USB_ENDPT8_EP_HSHK               (0x01)
#define MCF_USB_ENDPT8_EP_STALL              (0x02)
#define MCF_USB_ENDPT8_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT8_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT8_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT8_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT8_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT9 */
#define MCF_USB_ENDPT9_EP_HSHK               (0x01)
#define MCF_USB_ENDPT9_EP_STALL              (0x02)
#define MCF_USB_ENDPT9_EP_EN_TX              (0x04)
#define MCF_USB_ENDPT9_EP_EN_RX              (0x08)
#define MCF_USB_ENDPT9_EP_CTL_DIS            (0x10)
#define MCF_USB_ENDPT9_RETRY_DIS             (0x40)
#define MCF_USB_ENDPT9_HOST_WO_HUB           (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT10 */
#define MCF_USB_ENDPT10_EP_HSHK              (0x01)
#define MCF_USB_ENDPT10_EP_STALL             (0x02)
#define MCF_USB_ENDPT10_EP_EN_TX             (0x04)
#define MCF_USB_ENDPT10_EP_EN_RX             (0x08)
#define MCF_USB_ENDPT10_EP_CTL_DIS           (0x10)
#define MCF_USB_ENDPT10_RETRY_DIS            (0x40)
#define MCF_USB_ENDPT10_HOST_WO_HUB          (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT11 */
#define MCF_USB_ENDPT11_EP_HSHK              (0x01)
#define MCF_USB_ENDPT11_EP_STALL             (0x02)
#define MCF_USB_ENDPT11_EP_EN_TX             (0x04)
#define MCF_USB_ENDPT11_EP_EN_RX             (0x08)
#define MCF_USB_ENDPT11_EP_CTL_DIS           (0x10)
#define MCF_USB_ENDPT11_RETRY_DIS            (0x40)
#define MCF_USB_ENDPT11_HOST_WO_HUB          (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT12 */
#define MCF_USB_ENDPT12_EP_HSHK              (0x01)
#define MCF_USB_ENDPT12_EP_STALL             (0x02)
#define MCF_USB_ENDPT12_EP_EN_TX             (0x04)
#define MCF_USB_ENDPT12_EP_EN_RX             (0x08)
#define MCF_USB_ENDPT12_EP_CTL_DIS           (0x10)
#define MCF_USB_ENDPT12_RETRY_DIS            (0x40)
#define MCF_USB_ENDPT12_HOST_WO_HUB          (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT13 */
#define MCF_USB_ENDPT13_EP_HSHK              (0x01)
#define MCF_USB_ENDPT13_EP_STALL             (0x02)
#define MCF_USB_ENDPT13_EP_EN_TX             (0x04)
#define MCF_USB_ENDPT13_EP_EN_RX             (0x08)
#define MCF_USB_ENDPT13_EP_CTL_DIS           (0x10)
#define MCF_USB_ENDPT13_RETRY_DIS            (0x40)
#define MCF_USB_ENDPT13_HOST_WO_HUB          (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT14 */
#define MCF_USB_ENDPT14_EP_HSHK              (0x01)
#define MCF_USB_ENDPT14_EP_STALL             (0x02)
#define MCF_USB_ENDPT14_EP_EN_TX             (0x04)
#define MCF_USB_ENDPT14_EP_EN_RX             (0x08)
#define MCF_USB_ENDPT14_EP_CTL_DIS           (0x10)
#define MCF_USB_ENDPT14_RETRY_DIS            (0x40)
#define MCF_USB_ENDPT14_HOST_WO_HUB          (0x80)

/* Bit definitions and macros for MCF_USB_ENDPT15 */
#define MCF_USB_ENDPT15_EP_HSHK              (0x01)
#define MCF_USB_ENDPT15_EP_STALL             (0x02)
#define MCF_USB_ENDPT15_EP_EN_TX             (0x04)
#define MCF_USB_ENDPT15_EP_EN_RX             (0x08)
#define MCF_USB_ENDPT15_EP_CTL_DIS           (0x10)
#define MCF_USB_ENDPT15_RETRY_DIS            (0x40)
#define MCF_USB_ENDPT15_HOST_WO_HUB          (0x80)

/*********************************************************************
*
* Queued Serial Peripheral Interface (QSPI)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_QSPI_QMR           (*(hcc_reg16*)(&_IPSBAR[0x000340]))
#define MCF_QSPI_QDLYR         (*(hcc_reg16*)(&_IPSBAR[0x000344]))
#define MCF_QSPI_QWR           (*(hcc_reg16*)(&_IPSBAR[0x000348]))
#define MCF_QSPI_QIR           (*(hcc_reg16*)(&_IPSBAR[0x00034C]))
#define MCF_QSPI_QAR           (*(hcc_reg16*)(&_IPSBAR[0x000350]))
#define MCF_QSPI_QDR           (*(hcc_reg16*)(&_IPSBAR[0x000354]))

/* Bit definitions and macros for MCF_QSPI_QMR */
#define MCF_QSPI_QMR_BAUD(x)   (((x)&0x00FF)<<0)
#define MCF_QSPI_QMR_CPHA      (0x0100)
#define MCF_QSPI_QMR_CPOL      (0x0200)
#define MCF_QSPI_QMR_BITS(x)   (((x)&0x000F)<<10)
#define MCF_QSPI_QMR_DOHIE     (0x4000)
#define MCF_QSPI_QMR_MSTR      (0x8000)

/* Bit definitions and macros for MCF_QSPI_QDLYR */
#define MCF_QSPI_QDLYR_DTL(x)  (((x)&0x00FF)<<0)
#define MCF_QSPI_QDLYR_QCD(x)  (((x)&0x007F)<<8)
#define MCF_QSPI_QDLYR_SPE     (0x8000)

/* Bit definitions and macros for MCF_QSPI_QWR */
#define MCF_QSPI_QWR_NEWQP(x)  (((x)&0x000F)<<0)
#define MCF_QSPI_QWR_ENDQP(x)  (((x)&0x000F)<<8)
#define MCF_QSPI_QWR_CSIV      (0x1000)
#define MCF_QSPI_QWR_WRTO      (0x2000)
#define MCF_QSPI_QWR_WREN      (0x4000)
#define MCF_QSPI_QWR_HALT      (0x8000)

/* Bit definitions and macros for MCF_QSPI_QIR */
#define MCF_QSPI_QIR_SPIF      (0x0001)
#define MCF_QSPI_QIR_ABRT      (0x0004)
#define MCF_QSPI_QIR_WCEF      (0x0008)
#define MCF_QSPI_QIR_SPIFE     (0x0100)
#define MCF_QSPI_QIR_ABRTE     (0x0400)
#define MCF_QSPI_QIR_WCEFE     (0x0800)
#define MCF_QSPI_QIR_ABRTL     (0x1000)
#define MCF_QSPI_QIR_ABRTB     (0x4000)
#define MCF_QSPI_QIR_WCEFB     (0x8000)

/* Bit definitions and macros for MCF_QSPI_QAR */
#define MCF_QSPI_QAR_ADDR(x)   (((x)&0x003F)<<0)

/* Bit definitions and macros for MCF_QSPI_QDR */
#define MCF_QSPI_QDR_DATA(x)   (((x)&0xFFFF)<<0)

/*********************************************************************
*
* Interrupt Controller (INTC)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_INTC0_IPRH             (*(hcc_reg32*)(&_IPSBAR[0x000C00]))
#define MCF_INTC0_IPRL             (*(hcc_reg32*)(&_IPSBAR[0x000C04]))
#define MCF_INTC0_IMRH             (*(hcc_reg32*)(&_IPSBAR[0x000C08]))
#define MCF_INTC0_IMRL             (*(hcc_reg32*)(&_IPSBAR[0x000C0C]))
#define MCF_INTC0_INTFRCH          (*(hcc_reg32*)(&_IPSBAR[0x000C10]))
#define MCF_INTC0_INTFRCL          (*(hcc_reg32*)(&_IPSBAR[0x000C14]))
#define MCF_INTC0_IRLR             (*(hcc_reg8 *)(&_IPSBAR[0x000C18]))
#define MCF_INTC0_IACKLPR          (*(hcc_reg8 *)(&_IPSBAR[0x000C19]))
#define MCF_INTC0_ICR1             (*(hcc_reg8 *)(&_IPSBAR[0x000C41]))
#define MCF_INTC0_ICR2             (*(hcc_reg8 *)(&_IPSBAR[0x000C42]))
#define MCF_INTC0_ICR3             (*(hcc_reg8 *)(&_IPSBAR[0x000C43]))
#define MCF_INTC0_ICR4             (*(hcc_reg8 *)(&_IPSBAR[0x000C44]))
#define MCF_INTC0_ICR5             (*(hcc_reg8 *)(&_IPSBAR[0x000C45]))
#define MCF_INTC0_ICR6             (*(hcc_reg8 *)(&_IPSBAR[0x000C46]))
#define MCF_INTC0_ICR7             (*(hcc_reg8 *)(&_IPSBAR[0x000C47]))
#define MCF_INTC0_ICR8             (*(hcc_reg8 *)(&_IPSBAR[0x000C48]))
#define MCF_INTC0_ICR9             (*(hcc_reg8 *)(&_IPSBAR[0x000C49]))
#define MCF_INTC0_ICR10            (*(hcc_reg8 *)(&_IPSBAR[0x000C4A]))
#define MCF_INTC0_ICR11            (*(hcc_reg8 *)(&_IPSBAR[0x000C4B]))
#define MCF_INTC0_ICR12            (*(hcc_reg8 *)(&_IPSBAR[0x000C4C]))
#define MCF_INTC0_ICR13            (*(hcc_reg8 *)(&_IPSBAR[0x000C4D]))
#define MCF_INTC0_ICR14            (*(hcc_reg8 *)(&_IPSBAR[0x000C4E]))
#define MCF_INTC0_ICR15            (*(hcc_reg8 *)(&_IPSBAR[0x000C4F]))
#define MCF_INTC0_ICR16            (*(hcc_reg8 *)(&_IPSBAR[0x000C50]))
#define MCF_INTC0_ICR17            (*(hcc_reg8 *)(&_IPSBAR[0x000C51]))
#define MCF_INTC0_ICR18            (*(hcc_reg8 *)(&_IPSBAR[0x000C52]))
#define MCF_INTC0_ICR19            (*(hcc_reg8 *)(&_IPSBAR[0x000C53]))
#define MCF_INTC0_ICR20            (*(hcc_reg8 *)(&_IPSBAR[0x000C54]))
#define MCF_INTC0_ICR21            (*(hcc_reg8 *)(&_IPSBAR[0x000C55]))
#define MCF_INTC0_ICR22            (*(hcc_reg8 *)(&_IPSBAR[0x000C56]))
#define MCF_INTC0_ICR23            (*(hcc_reg8 *)(&_IPSBAR[0x000C57]))
#define MCF_INTC0_ICR24            (*(hcc_reg8 *)(&_IPSBAR[0x000C58]))
#define MCF_INTC0_ICR25            (*(hcc_reg8 *)(&_IPSBAR[0x000C59]))
#define MCF_INTC0_ICR26            (*(hcc_reg8 *)(&_IPSBAR[0x000C5A]))
#define MCF_INTC0_ICR27            (*(hcc_reg8 *)(&_IPSBAR[0x000C5B]))
#define MCF_INTC0_ICR28            (*(hcc_reg8 *)(&_IPSBAR[0x000C5C]))
#define MCF_INTC0_ICR29            (*(hcc_reg8 *)(&_IPSBAR[0x000C5D]))
#define MCF_INTC0_ICR30            (*(hcc_reg8 *)(&_IPSBAR[0x000C5E]))
#define MCF_INTC0_ICR31            (*(hcc_reg8 *)(&_IPSBAR[0x000C5F]))
#define MCF_INTC0_ICR32            (*(hcc_reg8 *)(&_IPSBAR[0x000C60]))
#define MCF_INTC0_ICR33            (*(hcc_reg8 *)(&_IPSBAR[0x000C61]))
#define MCF_INTC0_ICR34            (*(hcc_reg8 *)(&_IPSBAR[0x000C62]))
#define MCF_INTC0_ICR35            (*(hcc_reg8 *)(&_IPSBAR[0x000C63]))
#define MCF_INTC0_ICR36            (*(hcc_reg8 *)(&_IPSBAR[0x000C64]))
#define MCF_INTC0_ICR37            (*(hcc_reg8 *)(&_IPSBAR[0x000C65]))
#define MCF_INTC0_ICR38            (*(hcc_reg8 *)(&_IPSBAR[0x000C66]))
#define MCF_INTC0_ICR39            (*(hcc_reg8 *)(&_IPSBAR[0x000C67]))
#define MCF_INTC0_ICR40            (*(hcc_reg8 *)(&_IPSBAR[0x000C68]))
#define MCF_INTC0_ICR41            (*(hcc_reg8 *)(&_IPSBAR[0x000C69]))
#define MCF_INTC0_ICR42            (*(hcc_reg8 *)(&_IPSBAR[0x000C6A]))
#define MCF_INTC0_ICR43            (*(hcc_reg8 *)(&_IPSBAR[0x000C6B]))
#define MCF_INTC0_ICR44            (*(hcc_reg8 *)(&_IPSBAR[0x000C6C]))
#define MCF_INTC0_ICR45            (*(hcc_reg8 *)(&_IPSBAR[0x000C6D]))
#define MCF_INTC0_ICR46            (*(hcc_reg8 *)(&_IPSBAR[0x000C6E]))
#define MCF_INTC0_ICR47            (*(hcc_reg8 *)(&_IPSBAR[0x000C6F]))
#define MCF_INTC0_ICR48            (*(hcc_reg8 *)(&_IPSBAR[0x000C70]))
#define MCF_INTC0_ICR49            (*(hcc_reg8 *)(&_IPSBAR[0x000C71]))
#define MCF_INTC0_ICR50            (*(hcc_reg8 *)(&_IPSBAR[0x000C72]))
#define MCF_INTC0_ICR51            (*(hcc_reg8 *)(&_IPSBAR[0x000C73]))
#define MCF_INTC0_ICR52            (*(hcc_reg8 *)(&_IPSBAR[0x000C74]))
#define MCF_INTC0_ICR53            (*(hcc_reg8 *)(&_IPSBAR[0x000C75]))
#define MCF_INTC0_ICR54            (*(hcc_reg8 *)(&_IPSBAR[0x000C76]))
#define MCF_INTC0_ICR55            (*(hcc_reg8 *)(&_IPSBAR[0x000C77]))
#define MCF_INTC0_ICR56            (*(hcc_reg8 *)(&_IPSBAR[0x000C78]))
#define MCF_INTC0_ICR57            (*(hcc_reg8 *)(&_IPSBAR[0x000C79]))
#define MCF_INTC0_ICR58            (*(hcc_reg8 *)(&_IPSBAR[0x000C7A]))
#define MCF_INTC0_ICR59            (*(hcc_reg8 *)(&_IPSBAR[0x000C7B]))
#define MCF_INTC0_ICR60            (*(hcc_reg8 *)(&_IPSBAR[0x000C7C]))
#define MCF_INTC0_ICR61            (*(hcc_reg8 *)(&_IPSBAR[0x000C7D]))
#define MCF_INTC0_ICR62            (*(hcc_reg8 *)(&_IPSBAR[0x000C7E]))
#define MCF_INTC0_ICR63            (*(hcc_reg8 *)(&_IPSBAR[0x000C7F]))
#define MCF_INTC0_ICR(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C41+((x-1)*0x001)]))
#define MCF_INTC0_SWIACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CE0]))
#define MCF_INTC0_L1IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CE4]))
#define MCF_INTC0_L2IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CE8]))
#define MCF_INTC0_L3IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CEC]))
#define MCF_INTC0_L4IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CF0]))
#define MCF_INTC0_L5IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CF4]))
#define MCF_INTC0_L6IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CF8]))
#define MCF_INTC0_L7IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000CFC]))
#define MCF_INTC0_LIACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CE4+((x-1)*0x004)]))
#define MCF_INTC1_IPRH             (*(hcc_reg32*)(&_IPSBAR[0x000D00]))
#define MCF_INTC1_IPRL             (*(hcc_reg32*)(&_IPSBAR[0x000D04]))
#define MCF_INTC1_IMRH             (*(hcc_reg32*)(&_IPSBAR[0x000D08]))
#define MCF_INTC1_IMRL             (*(hcc_reg32*)(&_IPSBAR[0x000D0C]))
#define MCF_INTC1_INTFRCH          (*(hcc_reg32*)(&_IPSBAR[0x000D10]))
#define MCF_INTC1_INTFRCL          (*(hcc_reg32*)(&_IPSBAR[0x000D14]))
#define MCF_INTC1_IRLR             (*(hcc_reg8 *)(&_IPSBAR[0x000D18]))
#define MCF_INTC1_IACKLPR          (*(hcc_reg8 *)(&_IPSBAR[0x000D19]))
#define MCF_INTC1_ICR1             (*(hcc_reg8 *)(&_IPSBAR[0x000D41]))
#define MCF_INTC1_ICR2             (*(hcc_reg8 *)(&_IPSBAR[0x000D42]))
#define MCF_INTC1_ICR3             (*(hcc_reg8 *)(&_IPSBAR[0x000D43]))
#define MCF_INTC1_ICR4             (*(hcc_reg8 *)(&_IPSBAR[0x000D44]))
#define MCF_INTC1_ICR5             (*(hcc_reg8 *)(&_IPSBAR[0x000D45]))
#define MCF_INTC1_ICR6             (*(hcc_reg8 *)(&_IPSBAR[0x000D46]))
#define MCF_INTC1_ICR7             (*(hcc_reg8 *)(&_IPSBAR[0x000D47]))
#define MCF_INTC1_ICR8             (*(hcc_reg8 *)(&_IPSBAR[0x000D48]))
#define MCF_INTC1_ICR9             (*(hcc_reg8 *)(&_IPSBAR[0x000D49]))
#define MCF_INTC1_ICR10            (*(hcc_reg8 *)(&_IPSBAR[0x000D4A]))
#define MCF_INTC1_ICR11            (*(hcc_reg8 *)(&_IPSBAR[0x000D4B]))
#define MCF_INTC1_ICR12            (*(hcc_reg8 *)(&_IPSBAR[0x000D4C]))
#define MCF_INTC1_ICR13            (*(hcc_reg8 *)(&_IPSBAR[0x000D4D]))
#define MCF_INTC1_ICR14            (*(hcc_reg8 *)(&_IPSBAR[0x000D4E]))
#define MCF_INTC1_ICR15            (*(hcc_reg8 *)(&_IPSBAR[0x000D4F]))
#define MCF_INTC1_ICR16            (*(hcc_reg8 *)(&_IPSBAR[0x000D50]))
#define MCF_INTC1_ICR17            (*(hcc_reg8 *)(&_IPSBAR[0x000D51]))
#define MCF_INTC1_ICR18            (*(hcc_reg8 *)(&_IPSBAR[0x000D52]))
#define MCF_INTC1_ICR19            (*(hcc_reg8 *)(&_IPSBAR[0x000D53]))
#define MCF_INTC1_ICR20            (*(hcc_reg8 *)(&_IPSBAR[0x000D54]))
#define MCF_INTC1_ICR21            (*(hcc_reg8 *)(&_IPSBAR[0x000D55]))
#define MCF_INTC1_ICR22            (*(hcc_reg8 *)(&_IPSBAR[0x000D56]))
#define MCF_INTC1_ICR23            (*(hcc_reg8 *)(&_IPSBAR[0x000D57]))
#define MCF_INTC1_ICR24            (*(hcc_reg8 *)(&_IPSBAR[0x000D58]))
#define MCF_INTC1_ICR25            (*(hcc_reg8 *)(&_IPSBAR[0x000D59]))
#define MCF_INTC1_ICR26            (*(hcc_reg8 *)(&_IPSBAR[0x000D5A]))
#define MCF_INTC1_ICR27            (*(hcc_reg8 *)(&_IPSBAR[0x000D5B]))
#define MCF_INTC1_ICR28            (*(hcc_reg8 *)(&_IPSBAR[0x000D5C]))
#define MCF_INTC1_ICR29            (*(hcc_reg8 *)(&_IPSBAR[0x000D5D]))
#define MCF_INTC1_ICR30            (*(hcc_reg8 *)(&_IPSBAR[0x000D5E]))
#define MCF_INTC1_ICR31            (*(hcc_reg8 *)(&_IPSBAR[0x000D5F]))
#define MCF_INTC1_ICR32            (*(hcc_reg8 *)(&_IPSBAR[0x000D60]))
#define MCF_INTC1_ICR33            (*(hcc_reg8 *)(&_IPSBAR[0x000D61]))
#define MCF_INTC1_ICR34            (*(hcc_reg8 *)(&_IPSBAR[0x000D62]))
#define MCF_INTC1_ICR35            (*(hcc_reg8 *)(&_IPSBAR[0x000D63]))
#define MCF_INTC1_ICR36            (*(hcc_reg8 *)(&_IPSBAR[0x000D64]))
#define MCF_INTC1_ICR37            (*(hcc_reg8 *)(&_IPSBAR[0x000D65]))
#define MCF_INTC1_ICR38            (*(hcc_reg8 *)(&_IPSBAR[0x000D66]))
#define MCF_INTC1_ICR39            (*(hcc_reg8 *)(&_IPSBAR[0x000D67]))
#define MCF_INTC1_ICR40            (*(hcc_reg8 *)(&_IPSBAR[0x000D68]))
#define MCF_INTC1_ICR41            (*(hcc_reg8 *)(&_IPSBAR[0x000D69]))
#define MCF_INTC1_ICR42            (*(hcc_reg8 *)(&_IPSBAR[0x000D6A]))
#define MCF_INTC1_ICR43            (*(hcc_reg8 *)(&_IPSBAR[0x000D6B]))
#define MCF_INTC1_ICR44            (*(hcc_reg8 *)(&_IPSBAR[0x000D6C]))
#define MCF_INTC1_ICR45            (*(hcc_reg8 *)(&_IPSBAR[0x000D6D]))
#define MCF_INTC1_ICR46            (*(hcc_reg8 *)(&_IPSBAR[0x000D6E]))
#define MCF_INTC1_ICR47            (*(hcc_reg8 *)(&_IPSBAR[0x000D6F]))
#define MCF_INTC1_ICR48            (*(hcc_reg8 *)(&_IPSBAR[0x000D70]))
#define MCF_INTC1_ICR49            (*(hcc_reg8 *)(&_IPSBAR[0x000D71]))
#define MCF_INTC1_ICR50            (*(hcc_reg8 *)(&_IPSBAR[0x000D72]))
#define MCF_INTC1_ICR51            (*(hcc_reg8 *)(&_IPSBAR[0x000D73]))
#define MCF_INTC1_ICR52            (*(hcc_reg8 *)(&_IPSBAR[0x000D74]))
#define MCF_INTC1_ICR53            (*(hcc_reg8 *)(&_IPSBAR[0x000D75]))
#define MCF_INTC1_ICR54            (*(hcc_reg8 *)(&_IPSBAR[0x000D76]))
#define MCF_INTC1_ICR55            (*(hcc_reg8 *)(&_IPSBAR[0x000D77]))
#define MCF_INTC1_ICR56            (*(hcc_reg8 *)(&_IPSBAR[0x000D78]))
#define MCF_INTC1_ICR57            (*(hcc_reg8 *)(&_IPSBAR[0x000D79]))
#define MCF_INTC1_ICR58            (*(hcc_reg8 *)(&_IPSBAR[0x000D7A]))
#define MCF_INTC1_ICR59            (*(hcc_reg8 *)(&_IPSBAR[0x000D7B]))
#define MCF_INTC1_ICR60            (*(hcc_reg8 *)(&_IPSBAR[0x000D7C]))
#define MCF_INTC1_ICR61            (*(hcc_reg8 *)(&_IPSBAR[0x000D7D]))
#define MCF_INTC1_ICR62            (*(hcc_reg8 *)(&_IPSBAR[0x000D7E]))
#define MCF_INTC1_ICR63            (*(hcc_reg8 *)(&_IPSBAR[0x000D7F]))
#define MCF_INTC1_ICR(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000D41+((x-1)*0x001)]))
#define MCF_INTC1_SWIACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DE0]))
#define MCF_INTC1_L1IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DE4]))
#define MCF_INTC1_L2IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DE8]))
#define MCF_INTC1_L3IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DEC]))
#define MCF_INTC1_L4IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DF0]))
#define MCF_INTC1_L5IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DF4]))
#define MCF_INTC1_L6IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DF8]))
#define MCF_INTC1_L7IACK           (*(hcc_reg8 *)(&_IPSBAR[0x000DFC]))
#define MCF_INTC1_LIACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000DE4+((x-1)*0x004)]))
#define MCF_INTC_IPRH(x)           (*(hcc_reg32*)(&_IPSBAR[0x000C00+((x)*0x100)]))
#define MCF_INTC_IPRL(x)           (*(hcc_reg32*)(&_IPSBAR[0x000C04+((x)*0x100)]))
#define MCF_INTC_IMRH(x)           (*(hcc_reg32*)(&_IPSBAR[0x000C08+((x)*0x100)]))
#define MCF_INTC_IMRL(x)           (*(hcc_reg32*)(&_IPSBAR[0x000C0C+((x)*0x100)]))
#define MCF_INTC_INTFRCH(x)        (*(hcc_reg32*)(&_IPSBAR[0x000C10+((x)*0x100)]))
#define MCF_INTC_INTFRCL(x)        (*(hcc_reg32*)(&_IPSBAR[0x000C14+((x)*0x100)]))
#define MCF_INTC_IRLR(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C18+((x)*0x100)]))
#define MCF_INTC_IACKLPR(x)        (*(hcc_reg8 *)(&_IPSBAR[0x000C19+((x)*0x100)]))
#define MCF_INTC_ICR1(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C41+((x)*0x100)]))
#define MCF_INTC_ICR2(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C42+((x)*0x100)]))
#define MCF_INTC_ICR3(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C43+((x)*0x100)]))
#define MCF_INTC_ICR4(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C44+((x)*0x100)]))
#define MCF_INTC_ICR5(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C45+((x)*0x100)]))
#define MCF_INTC_ICR6(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C46+((x)*0x100)]))
#define MCF_INTC_ICR7(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C47+((x)*0x100)]))
#define MCF_INTC_ICR8(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C48+((x)*0x100)]))
#define MCF_INTC_ICR9(x)           (*(hcc_reg8 *)(&_IPSBAR[0x000C49+((x)*0x100)]))
#define MCF_INTC_ICR10(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C4A+((x)*0x100)]))
#define MCF_INTC_ICR11(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C4B+((x)*0x100)]))
#define MCF_INTC_ICR12(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C4C+((x)*0x100)]))
#define MCF_INTC_ICR13(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C4D+((x)*0x100)]))
#define MCF_INTC_ICR14(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C4E+((x)*0x100)]))
#define MCF_INTC_ICR15(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C4F+((x)*0x100)]))
#define MCF_INTC_ICR16(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C50+((x)*0x100)]))
#define MCF_INTC_ICR17(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C51+((x)*0x100)]))
#define MCF_INTC_ICR18(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C52+((x)*0x100)]))
#define MCF_INTC_ICR19(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C53+((x)*0x100)]))
#define MCF_INTC_ICR20(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C54+((x)*0x100)]))
#define MCF_INTC_ICR21(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C55+((x)*0x100)]))
#define MCF_INTC_ICR22(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C56+((x)*0x100)]))
#define MCF_INTC_ICR23(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C57+((x)*0x100)]))
#define MCF_INTC_ICR24(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C58+((x)*0x100)]))
#define MCF_INTC_ICR25(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C59+((x)*0x100)]))
#define MCF_INTC_ICR26(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C5A+((x)*0x100)]))
#define MCF_INTC_ICR27(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C5B+((x)*0x100)]))
#define MCF_INTC_ICR28(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C5C+((x)*0x100)]))
#define MCF_INTC_ICR29(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C5D+((x)*0x100)]))
#define MCF_INTC_ICR30(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C5E+((x)*0x100)]))
#define MCF_INTC_ICR31(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C5F+((x)*0x100)]))
#define MCF_INTC_ICR32(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C60+((x)*0x100)]))
#define MCF_INTC_ICR33(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C61+((x)*0x100)]))
#define MCF_INTC_ICR34(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C62+((x)*0x100)]))
#define MCF_INTC_ICR35(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C63+((x)*0x100)]))
#define MCF_INTC_ICR36(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C64+((x)*0x100)]))
#define MCF_INTC_ICR37(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C65+((x)*0x100)]))
#define MCF_INTC_ICR38(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C66+((x)*0x100)]))
#define MCF_INTC_ICR39(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C67+((x)*0x100)]))
#define MCF_INTC_ICR40(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C68+((x)*0x100)]))
#define MCF_INTC_ICR41(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C69+((x)*0x100)]))
#define MCF_INTC_ICR42(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C6A+((x)*0x100)]))
#define MCF_INTC_ICR43(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C6B+((x)*0x100)]))
#define MCF_INTC_ICR44(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C6C+((x)*0x100)]))
#define MCF_INTC_ICR45(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C6D+((x)*0x100)]))
#define MCF_INTC_ICR46(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C6E+((x)*0x100)]))
#define MCF_INTC_ICR47(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C6F+((x)*0x100)]))
#define MCF_INTC_ICR48(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C70+((x)*0x100)]))
#define MCF_INTC_ICR49(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C71+((x)*0x100)]))
#define MCF_INTC_ICR50(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C72+((x)*0x100)]))
#define MCF_INTC_ICR51(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C73+((x)*0x100)]))
#define MCF_INTC_ICR52(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C74+((x)*0x100)]))
#define MCF_INTC_ICR53(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C75+((x)*0x100)]))
#define MCF_INTC_ICR54(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C76+((x)*0x100)]))
#define MCF_INTC_ICR55(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C77+((x)*0x100)]))
#define MCF_INTC_ICR56(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C78+((x)*0x100)]))
#define MCF_INTC_ICR57(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C79+((x)*0x100)]))
#define MCF_INTC_ICR58(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C7A+((x)*0x100)]))
#define MCF_INTC_ICR59(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C7B+((x)*0x100)]))
#define MCF_INTC_ICR60(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C7C+((x)*0x100)]))
#define MCF_INTC_ICR61(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C7D+((x)*0x100)]))
#define MCF_INTC_ICR62(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C7E+((x)*0x100)]))
#define MCF_INTC_ICR63(x)          (*(hcc_reg8 *)(&_IPSBAR[0x000C7F+((x)*0x100)]))
#define MCF_INTC_SWIACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CE0+((x)*0x100)]))
#define MCF_INTC_L1IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CE4+((x)*0x100)]))
#define MCF_INTC_L2IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CE8+((x)*0x100)]))
#define MCF_INTC_L3IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CEC+((x)*0x100)]))
#define MCF_INTC_L4IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CF0+((x)*0x100)]))
#define MCF_INTC_L5IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CF4+((x)*0x100)]))
#define MCF_INTC_L6IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CF8+((x)*0x100)]))
#define MCF_INTC_L7IACK(x)         (*(hcc_reg8 *)(&_IPSBAR[0x000CFC+((x)*0x100)]))

/* Bit definitions and macros for MCF_INTC_IPRH */
#define MCF_INTC_IPRH_INT32        (0x00000001)
#define MCF_INTC_IPRH_INT33        (0x00000002)
#define MCF_INTC_IPRH_INT34        (0x00000004)
#define MCF_INTC_IPRH_INT35        (0x00000008)
#define MCF_INTC_IPRH_INT36        (0x00000010)
#define MCF_INTC_IPRH_INT37        (0x00000020)
#define MCF_INTC_IPRH_INT38        (0x00000040)
#define MCF_INTC_IPRH_INT39        (0x00000080)
#define MCF_INTC_IPRH_INT40        (0x00000100)
#define MCF_INTC_IPRH_INT41        (0x00000200)
#define MCF_INTC_IPRH_INT42        (0x00000400)
#define MCF_INTC_IPRH_INT43        (0x00000800)
#define MCF_INTC_IPRH_INT44        (0x00001000)
#define MCF_INTC_IPRH_INT45        (0x00002000)
#define MCF_INTC_IPRH_INT46        (0x00004000)
#define MCF_INTC_IPRH_INT47        (0x00008000)
#define MCF_INTC_IPRH_INT48        (0x00010000)
#define MCF_INTC_IPRH_INT49        (0x00020000)
#define MCF_INTC_IPRH_INT50        (0x00040000)
#define MCF_INTC_IPRH_INT51        (0x00080000)
#define MCF_INTC_IPRH_INT52        (0x00100000)
#define MCF_INTC_IPRH_INT53        (0x00200000)
#define MCF_INTC_IPRH_INT54        (0x00400000)
#define MCF_INTC_IPRH_INT55        (0x00800000)
#define MCF_INTC_IPRH_INT56        (0x01000000)
#define MCF_INTC_IPRH_INT57        (0x02000000)
#define MCF_INTC_IPRH_INT58        (0x04000000)
#define MCF_INTC_IPRH_INT59        (0x08000000)
#define MCF_INTC_IPRH_INT60        (0x10000000)
#define MCF_INTC_IPRH_INT61        (0x20000000)
#define MCF_INTC_IPRH_INT62        (0x40000000)
#define MCF_INTC_IPRH_INT63        (0x80000000)

/* Bit definitions and macros for MCF_INTC_IPRL */
#define MCF_INTC_IPRL_INT1         (0x00000002)
#define MCF_INTC_IPRL_INT2         (0x00000004)
#define MCF_INTC_IPRL_INT3         (0x00000008)
#define MCF_INTC_IPRL_INT4         (0x00000010)
#define MCF_INTC_IPRL_INT5         (0x00000020)
#define MCF_INTC_IPRL_INT6         (0x00000040)
#define MCF_INTC_IPRL_INT7         (0x00000080)
#define MCF_INTC_IPRL_INT8         (0x00000100)
#define MCF_INTC_IPRL_INT9         (0x00000200)
#define MCF_INTC_IPRL_INT10        (0x00000400)
#define MCF_INTC_IPRL_INT11        (0x00000800)
#define MCF_INTC_IPRL_INT12        (0x00001000)
#define MCF_INTC_IPRL_INT13        (0x00002000)
#define MCF_INTC_IPRL_INT14        (0x00004000)
#define MCF_INTC_IPRL_INT15        (0x00008000)
#define MCF_INTC_IPRL_INT16        (0x00010000)
#define MCF_INTC_IPRL_INT17        (0x00020000)
#define MCF_INTC_IPRL_INT18        (0x00040000)
#define MCF_INTC_IPRL_INT19        (0x00080000)
#define MCF_INTC_IPRL_INT20        (0x00100000)
#define MCF_INTC_IPRL_INT21        (0x00200000)
#define MCF_INTC_IPRL_INT22        (0x00400000)
#define MCF_INTC_IPRL_INT23        (0x00800000)
#define MCF_INTC_IPRL_INT24        (0x01000000)
#define MCF_INTC_IPRL_INT25        (0x02000000)
#define MCF_INTC_IPRL_INT26        (0x04000000)
#define MCF_INTC_IPRL_INT27        (0x08000000)
#define MCF_INTC_IPRL_INT28        (0x10000000)
#define MCF_INTC_IPRL_INT29        (0x20000000)
#define MCF_INTC_IPRL_INT30        (0x40000000)
#define MCF_INTC_IPRL_INT31        (0x80000000)

/* Bit definitions and macros for MCF_INTC_IMRH */
#define MCF_INTC_IMRH_MASK32       (0x00000001)
#define MCF_INTC_IMRH_MASK33       (0x00000002)
#define MCF_INTC_IMRH_MASK34       (0x00000004)
#define MCF_INTC_IMRH_MASK35       (0x00000008)
#define MCF_INTC_IMRH_MASK36       (0x00000010)
#define MCF_INTC_IMRH_MASK37       (0x00000020)
#define MCF_INTC_IMRH_MASK38       (0x00000040)
#define MCF_INTC_IMRH_MASK39       (0x00000080)
#define MCF_INTC_IMRH_MASK40       (0x00000100)
#define MCF_INTC_IMRH_MASK41       (0x00000200)
#define MCF_INTC_IMRH_MASK42       (0x00000400)
#define MCF_INTC_IMRH_MASK43       (0x00000800)
#define MCF_INTC_IMRH_MASK44       (0x00001000)
#define MCF_INTC_IMRH_MASK45       (0x00002000)
#define MCF_INTC_IMRH_MASK46       (0x00004000)
#define MCF_INTC_IMRH_MASK47       (0x00008000)
#define MCF_INTC_IMRH_MASK48       (0x00010000)
#define MCF_INTC_IMRH_MASK49       (0x00020000)
#define MCF_INTC_IMRH_MASK50       (0x00040000)
#define MCF_INTC_IMRH_MASK51       (0x00080000)
#define MCF_INTC_IMRH_MASK52       (0x00100000)
#define MCF_INTC_IMRH_MASK53       (0x00200000)
#define MCF_INTC_IMRH_MASK54       (0x00400000)
#define MCF_INTC_IMRH_MASK55       (0x00800000)
#define MCF_INTC_IMRH_MASK56       (0x01000000)
#define MCF_INTC_IMRH_MASK57       (0x02000000)
#define MCF_INTC_IMRH_MASK58       (0x04000000)
#define MCF_INTC_IMRH_MASK59       (0x08000000)
#define MCF_INTC_IMRH_MASK60       (0x10000000)
#define MCF_INTC_IMRH_MASK61       (0x20000000)
#define MCF_INTC_IMRH_MASK62       (0x40000000)
#define MCF_INTC_IMRH_MASK63       (0x80000000)

/* Bit definitions and macros for MCF_INTC_IMRL */
#define MCF_INTC_IMRL_MASKALL      (0x00000001)
#define MCF_INTC_IMRL_MASK1        (0x00000002)
#define MCF_INTC_IMRL_MASK2        (0x00000004)
#define MCF_INTC_IMRL_MASK3        (0x00000008)
#define MCF_INTC_IMRL_MASK4        (0x00000010)
#define MCF_INTC_IMRL_MASK5        (0x00000020)
#define MCF_INTC_IMRL_MASK6        (0x00000040)
#define MCF_INTC_IMRL_MASK7        (0x00000080)
#define MCF_INTC_IMRL_MASK8        (0x00000100)
#define MCF_INTC_IMRL_MASK9        (0x00000200)
#define MCF_INTC_IMRL_MASK10       (0x00000400)
#define MCF_INTC_IMRL_MASK11       (0x00000800)
#define MCF_INTC_IMRL_MASK12       (0x00001000)
#define MCF_INTC_IMRL_MASK13       (0x00002000)
#define MCF_INTC_IMRL_MASK14       (0x00004000)
#define MCF_INTC_IMRL_MASK15       (0x00008000)
#define MCF_INTC_IMRL_MASK16       (0x00010000)
#define MCF_INTC_IMRL_MASK17       (0x00020000)
#define MCF_INTC_IMRL_MASK18       (0x00040000)
#define MCF_INTC_IMRL_MASK19       (0x00080000)
#define MCF_INTC_IMRL_MASK20       (0x00100000)
#define MCF_INTC_IMRL_MASK21       (0x00200000)
#define MCF_INTC_IMRL_MASK22       (0x00400000)
#define MCF_INTC_IMRL_MASK23       (0x00800000)
#define MCF_INTC_IMRL_MASK24       (0x01000000)
#define MCF_INTC_IMRL_MASK25       (0x02000000)
#define MCF_INTC_IMRL_MASK26       (0x04000000)
#define MCF_INTC_IMRL_MASK27       (0x08000000)
#define MCF_INTC_IMRL_MASK28       (0x10000000)
#define MCF_INTC_IMRL_MASK29       (0x20000000)
#define MCF_INTC_IMRL_MASK30       (0x40000000)
#define MCF_INTC_IMRL_MASK31       (0x80000000)

/* Bit definitions and macros for MCF_INTC_INTFRCH */
#define MCF_INTC_INTFRCH_INTFRC32  (0x00000001)
#define MCF_INTC_INTFRCH_INTFRC33  (0x00000002)
#define MCF_INTC_INTFRCH_INTFRC34  (0x00000004)
#define MCF_INTC_INTFRCH_INTFRC35  (0x00000008)
#define MCF_INTC_INTFRCH_INTFRC36  (0x00000010)
#define MCF_INTC_INTFRCH_INTFRC37  (0x00000020)
#define MCF_INTC_INTFRCH_INTFRC38  (0x00000040)
#define MCF_INTC_INTFRCH_INTFRC39  (0x00000080)
#define MCF_INTC_INTFRCH_INTFRC40  (0x00000100)
#define MCF_INTC_INTFRCH_INTFRC41  (0x00000200)
#define MCF_INTC_INTFRCH_INTFRC42  (0x00000400)
#define MCF_INTC_INTFRCH_INTFRC43  (0x00000800)
#define MCF_INTC_INTFRCH_INTFRC44  (0x00001000)
#define MCF_INTC_INTFRCH_INTFRC45  (0x00002000)
#define MCF_INTC_INTFRCH_INTFRC46  (0x00004000)
#define MCF_INTC_INTFRCH_INTFRC47  (0x00008000)
#define MCF_INTC_INTFRCH_INTFRC48  (0x00010000)
#define MCF_INTC_INTFRCH_INTFRC49  (0x00020000)
#define MCF_INTC_INTFRCH_INTFRC50  (0x00040000)
#define MCF_INTC_INTFRCH_INTFRC51  (0x00080000)
#define MCF_INTC_INTFRCH_INTFRC52  (0x00100000)
#define MCF_INTC_INTFRCH_INTFRC53  (0x00200000)
#define MCF_INTC_INTFRCH_INTFRC54  (0x00400000)
#define MCF_INTC_INTFRCH_INTFRC55  (0x00800000)
#define MCF_INTC_INTFRCH_INTFRC56  (0x01000000)
#define MCF_INTC_INTFRCH_INTFRC57  (0x02000000)
#define MCF_INTC_INTFRCH_INTFRC58  (0x04000000)
#define MCF_INTC_INTFRCH_INTFRC59  (0x08000000)
#define MCF_INTC_INTFRCH_INTFRC60  (0x10000000)
#define MCF_INTC_INTFRCH_INTFRC61  (0x20000000)
#define MCF_INTC_INTFRCH_INTFRC62  (0x40000000)
#define MCF_INTC_INTFRCH_INTFRC63  (0x80000000)

/* Bit definitions and macros for MCF_INTC_INTFRCL */
#define MCF_INTC_INTFRCL_INTFRC1   (0x00000002)
#define MCF_INTC_INTFRCL_INTFRC2   (0x00000004)
#define MCF_INTC_INTFRCL_INTFRC3   (0x00000008)
#define MCF_INTC_INTFRCL_INTFRC4   (0x00000010)
#define MCF_INTC_INTFRCL_INTFRC5   (0x00000020)
#define MCF_INTC_INTFRCL_INTFRC6   (0x00000040)
#define MCF_INTC_INTFRCL_INTFRC7   (0x00000080)
#define MCF_INTC_INTFRCL_INTFRC8   (0x00000100)
#define MCF_INTC_INTFRCL_INTFRC9   (0x00000200)
#define MCF_INTC_INTFRCL_INTFRC10  (0x00000400)
#define MCF_INTC_INTFRCL_INTFRC11  (0x00000800)
#define MCF_INTC_INTFRCL_INTFRC12  (0x00001000)
#define MCF_INTC_INTFRCL_INTFRC13  (0x00002000)
#define MCF_INTC_INTFRCL_INTFRC14  (0x00004000)
#define MCF_INTC_INTFRCL_INTFRC15  (0x00008000)
#define MCF_INTC_INTFRCL_INTFRC16  (0x00010000)
#define MCF_INTC_INTFRCL_INTFRC17  (0x00020000)
#define MCF_INTC_INTFRCL_INTFRC18  (0x00040000)
#define MCF_INTC_INTFRCL_INTFRC19  (0x00080000)
#define MCF_INTC_INTFRCL_INTFRC20  (0x00100000)
#define MCF_INTC_INTFRCL_INTFRC21  (0x00200000)
#define MCF_INTC_INTFRCL_INTFRC22  (0x00400000)
#define MCF_INTC_INTFRCL_INTFRC23  (0x00800000)
#define MCF_INTC_INTFRCL_INTFRC24  (0x01000000)
#define MCF_INTC_INTFRCL_INTFRC25  (0x02000000)
#define MCF_INTC_INTFRCL_INTFRC26  (0x04000000)
#define MCF_INTC_INTFRCL_INTFRC27  (0x08000000)
#define MCF_INTC_INTFRCL_INTFRC28  (0x10000000)
#define MCF_INTC_INTFRCL_INTFRC29  (0x20000000)
#define MCF_INTC_INTFRCL_INTFRC30  (0x40000000)
#define MCF_INTC_INTFRCL_INTFRC31  (0x80000000)

/* Bit definitions and macros for MCF_INTC_IRLR */
#define MCF_INTC_IRLR_IRQ(x)       (((x)&0x7F)<<1)

/* Bit definitions and macros for MCF_INTC_IACKLPR */
#define MCF_INTC_IACKLPR_PRI(x)    (((x)&0x0F)<<0)
#define MCF_INTC_IACKLPR_LEVEL(x)  (((x)&0x07)<<4)

/* Bit definitions and macros for MCF_INTC_ICR */
#define MCF_INTC_ICR_IP(x)         (((x)&0x07)<<0)
#define MCF_INTC_ICR_IL(x)         (((x)&0x07)<<3)

/* Bit definitions and macros for MCF_INTC_SWIACK */
#define MCF_INTC_SWIACK_VECTOR(x)  (((x)&0xFF)<<0)

/* Bit definitions and macros for MCF_INTC_LIACK */
#define MCF_INTC_LIACK_VECTOR(x)   (((x)&0xFF)<<0)

/*********************************************************************
*
* General Purpose I/O (GPIO)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_GPIO_PORTNQ                   (*(hcc_reg8 *)(&_IPSBAR[0x100008]))
#define MCF_GPIO_PORTAN                   (*(hcc_reg8 *)(&_IPSBAR[0x10000A]))
#define MCF_GPIO_PORTAS                   (*(hcc_reg8 *)(&_IPSBAR[0x10000B]))
#define MCF_GPIO_PORTQS                   (*(hcc_reg8 *)(&_IPSBAR[0x10000C]))
#define MCF_GPIO_PORTTA                   (*(hcc_reg8 *)(&_IPSBAR[0x10000E]))
#define MCF_GPIO_PORTTC                   (*(hcc_reg8 *)(&_IPSBAR[0x10000F]))
#define MCF_GPIO_PORTUA                   (*(hcc_reg8 *)(&_IPSBAR[0x100011]))
#define MCF_GPIO_PORTUB                   (*(hcc_reg8 *)(&_IPSBAR[0x100012]))
#define MCF_GPIO_PORTUC                   (*(hcc_reg8 *)(&_IPSBAR[0x100013]))
#define MCF_GPIO_PORTDD                   (*(hcc_reg8 *)(&_IPSBAR[0x100014]))
#define MCF_GPIO_DDRNQ                    (*(hcc_reg8 *)(&_IPSBAR[0x100020]))
#define MCF_GPIO_DDRAN                    (*(hcc_reg8 *)(&_IPSBAR[0x100022]))
#define MCF_GPIO_DDRAS                    (*(hcc_reg8 *)(&_IPSBAR[0x100023]))
#define MCF_GPIO_DDRQS                    (*(hcc_reg8 *)(&_IPSBAR[0x100024]))
#define MCF_GPIO_DDRTA                    (*(hcc_reg8 *)(&_IPSBAR[0x100026]))
#define MCF_GPIO_DDRTC                    (*(hcc_reg8 *)(&_IPSBAR[0x100027]))
#define MCF_GPIO_DDRUA                    (*(hcc_reg8 *)(&_IPSBAR[0x100029]))
#define MCF_GPIO_DDRUB                    (*(hcc_reg8 *)(&_IPSBAR[0x10002A]))
#define MCF_GPIO_DDRUC                    (*(hcc_reg8 *)(&_IPSBAR[0x10002B]))
#define MCF_GPIO_DDRDD                    (*(hcc_reg8 *)(&_IPSBAR[0x10002C]))
#define MCF_GPIO_SETNQ                    (*(hcc_reg8 *)(&_IPSBAR[0x100038]))
#define MCF_GPIO_SETAN                    (*(hcc_reg8 *)(&_IPSBAR[0x10003A]))
#define MCF_GPIO_SETAS                    (*(hcc_reg8 *)(&_IPSBAR[0x10003B]))
#define MCF_GPIO_SETQS                    (*(hcc_reg8 *)(&_IPSBAR[0x10003C]))
#define MCF_GPIO_SETTA                    (*(hcc_reg8 *)(&_IPSBAR[0x10003E]))
#define MCF_GPIO_SETTC                    (*(hcc_reg8 *)(&_IPSBAR[0x10003F]))
#define MCF_GPIO_SETUA                    (*(hcc_reg8 *)(&_IPSBAR[0x100041]))
#define MCF_GPIO_SETUB                    (*(hcc_reg8 *)(&_IPSBAR[0x100042]))
#define MCF_GPIO_SETUC                    (*(hcc_reg8 *)(&_IPSBAR[0x100043]))
#define MCF_GPIO_SETDD                    (*(hcc_reg8 *)(&_IPSBAR[0x100044]))
#define MCF_GPIO_CLRNQ                    (*(hcc_reg8 *)(&_IPSBAR[0x100050]))
#define MCF_GPIO_CLRAN                    (*(hcc_reg8 *)(&_IPSBAR[0x100052]))
#define MCF_GPIO_CLRAS                    (*(hcc_reg8 *)(&_IPSBAR[0x100053]))
#define MCF_GPIO_CLRQS                    (*(hcc_reg8 *)(&_IPSBAR[0x100054]))
#define MCF_GPIO_CLRTA                    (*(hcc_reg8 *)(&_IPSBAR[0x100056]))
#define MCF_GPIO_CLRTC                    (*(hcc_reg8 *)(&_IPSBAR[0x100057]))
#define MCF_GPIO_CLRUA                    (*(hcc_reg8 *)(&_IPSBAR[0x100059]))
#define MCF_GPIO_CLRUB                    (*(hcc_reg8 *)(&_IPSBAR[0x10005A]))
#define MCF_GPIO_CLRUC                    (*(hcc_reg8 *)(&_IPSBAR[0x10005B]))
#define MCF_GPIO_CLRDD                    (*(hcc_reg8 *)(&_IPSBAR[0x10005C]))
#define MCF_GPIO_PNQPAR                   (*(hcc_reg16*)(&_IPSBAR[0x100068]))
#define MCF_GPIO_PANPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x10006A]))
#define MCF_GPIO_PASPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x10006B]))
#define MCF_GPIO_PQSPAR                   (*(hcc_reg16*)(&_IPSBAR[0x10006C]))
#define MCF_GPIO_PTAPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x10006E]))
#define MCF_GPIO_PTCPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x10006F]))
#define MCF_GPIO_PUAPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x100071]))
#define MCF_GPIO_PUBPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x100072]))
#define MCF_GPIO_PUCPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x100073]))
#define MCF_GPIO_PDDPAR                   (*(hcc_reg8 *)(&_IPSBAR[0x100074]))
#define MCF_GPIO_PSSR                     (*(hcc_reg32*)(&_IPSBAR[0x100078]))
#define MCF_GPIO_PDSR                     (*(hcc_reg32*)(&_IPSBAR[0x10007C]))

/* Bit definitions and macros for MCF_GPIO_PORTNQ */
#define MCF_GPIO_PORTNQ_PORTNQ0           (0x01)
#define MCF_GPIO_PORTNQ_PORTNQ1           (0x02)
#define MCF_GPIO_PORTNQ_PORTNQ2           (0x04)
#define MCF_GPIO_PORTNQ_PORTNQ3           (0x08)
#define MCF_GPIO_PORTNQ_PORTNQ4           (0x10)
#define MCF_GPIO_PORTNQ_PORTNQ5           (0x20)
#define MCF_GPIO_PORTNQ_PORTNQ6           (0x40)
#define MCF_GPIO_PORTNQ_PORTNQ7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTAN */
#define MCF_GPIO_PORTAN_PORTAN0           (0x01)
#define MCF_GPIO_PORTAN_PORTAN1           (0x02)
#define MCF_GPIO_PORTAN_PORTAN2           (0x04)
#define MCF_GPIO_PORTAN_PORTAN3           (0x08)
#define MCF_GPIO_PORTAN_PORTAN4           (0x10)
#define MCF_GPIO_PORTAN_PORTAN5           (0x20)
#define MCF_GPIO_PORTAN_PORTAN6           (0x40)
#define MCF_GPIO_PORTAN_PORTAN7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTAS */
#define MCF_GPIO_PORTAS_PORTAS0           (0x01)
#define MCF_GPIO_PORTAS_PORTAS1           (0x02)
#define MCF_GPIO_PORTAS_PORTAS2           (0x04)
#define MCF_GPIO_PORTAS_PORTAS3           (0x08)
#define MCF_GPIO_PORTAS_PORTAS4           (0x10)
#define MCF_GPIO_PORTAS_PORTAS5           (0x20)
#define MCF_GPIO_PORTAS_PORTAS6           (0x40)
#define MCF_GPIO_PORTAS_PORTAS7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTQS */
#define MCF_GPIO_PORTQS_PORTQS0           (0x01)
#define MCF_GPIO_PORTQS_PORTQS1           (0x02)
#define MCF_GPIO_PORTQS_PORTQS2           (0x04)
#define MCF_GPIO_PORTQS_PORTQS3           (0x08)
#define MCF_GPIO_PORTQS_PORTQS4           (0x10)
#define MCF_GPIO_PORTQS_PORTQS5           (0x20)
#define MCF_GPIO_PORTQS_PORTQS6           (0x40)
#define MCF_GPIO_PORTQS_PORTQS7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTTA */
#define MCF_GPIO_PORTTA_PORTTA0           (0x01)
#define MCF_GPIO_PORTTA_PORTTA1           (0x02)
#define MCF_GPIO_PORTTA_PORTTA2           (0x04)
#define MCF_GPIO_PORTTA_PORTTA3           (0x08)
#define MCF_GPIO_PORTTA_PORTTA4           (0x10)
#define MCF_GPIO_PORTTA_PORTTA5           (0x20)
#define MCF_GPIO_PORTTA_PORTTA6           (0x40)
#define MCF_GPIO_PORTTA_PORTTA7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTTC */
#define MCF_GPIO_PORTTC_PORTTC0           (0x01)
#define MCF_GPIO_PORTTC_PORTTC1           (0x02)
#define MCF_GPIO_PORTTC_PORTTC2           (0x04)
#define MCF_GPIO_PORTTC_PORTTC3           (0x08)
#define MCF_GPIO_PORTTC_PORTTC4           (0x10)
#define MCF_GPIO_PORTTC_PORTTC5           (0x20)
#define MCF_GPIO_PORTTC_PORTTC6           (0x40)
#define MCF_GPIO_PORTTC_PORTTC7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTUA */
#define MCF_GPIO_PORTUA_PORTUA0           (0x01)
#define MCF_GPIO_PORTUA_PORTUA1           (0x02)
#define MCF_GPIO_PORTUA_PORTUA2           (0x04)
#define MCF_GPIO_PORTUA_PORTUA3           (0x08)
#define MCF_GPIO_PORTUA_PORTUA4           (0x10)
#define MCF_GPIO_PORTUA_PORTUA5           (0x20)
#define MCF_GPIO_PORTUA_PORTUA6           (0x40)
#define MCF_GPIO_PORTUA_PORTUA7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTUB */
#define MCF_GPIO_PORTUB_PORTUB0           (0x01)
#define MCF_GPIO_PORTUB_PORTUB1           (0x02)
#define MCF_GPIO_PORTUB_PORTUB2           (0x04)
#define MCF_GPIO_PORTUB_PORTUB3           (0x08)
#define MCF_GPIO_PORTUB_PORTUB4           (0x10)
#define MCF_GPIO_PORTUB_PORTUB5           (0x20)
#define MCF_GPIO_PORTUB_PORTUB6           (0x40)
#define MCF_GPIO_PORTUB_PORTUB7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTUC */
#define MCF_GPIO_PORTUC_PORTUC0           (0x01)
#define MCF_GPIO_PORTUC_PORTUC1           (0x02)
#define MCF_GPIO_PORTUC_PORTUC2           (0x04)
#define MCF_GPIO_PORTUC_PORTUC3           (0x08)
#define MCF_GPIO_PORTUC_PORTUC4           (0x10)
#define MCF_GPIO_PORTUC_PORTUC5           (0x20)
#define MCF_GPIO_PORTUC_PORTUC6           (0x40)
#define MCF_GPIO_PORTUC_PORTUC7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PORTDD */
#define MCF_GPIO_PORTDD_PORTDD0           (0x01)
#define MCF_GPIO_PORTDD_PORTDD1           (0x02)
#define MCF_GPIO_PORTDD_PORTDD2           (0x04)
#define MCF_GPIO_PORTDD_PORTDD3           (0x08)
#define MCF_GPIO_PORTDD_PORTDD4           (0x10)
#define MCF_GPIO_PORTDD_PORTDD5           (0x20)
#define MCF_GPIO_PORTDD_PORTDD6           (0x40)
#define MCF_GPIO_PORTDD_PORTDD7           (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRNQ */
#define MCF_GPIO_DDRNQ_DDRNQ0             (0x01)
#define MCF_GPIO_DDRNQ_DDRNQ1             (0x02)
#define MCF_GPIO_DDRNQ_DDRNQ2             (0x04)
#define MCF_GPIO_DDRNQ_DDRNQ3             (0x08)
#define MCF_GPIO_DDRNQ_DDRNQ4             (0x10)
#define MCF_GPIO_DDRNQ_DDRNQ5             (0x20)
#define MCF_GPIO_DDRNQ_DDRNQ6             (0x40)
#define MCF_GPIO_DDRNQ_DDRNQ7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRAN */
#define MCF_GPIO_DDRAN_DDRAN0             (0x01)
#define MCF_GPIO_DDRAN_DDRAN1             (0x02)
#define MCF_GPIO_DDRAN_DDRAN2             (0x04)
#define MCF_GPIO_DDRAN_DDRAN3             (0x08)
#define MCF_GPIO_DDRAN_DDRAN4             (0x10)
#define MCF_GPIO_DDRAN_DDRAN5             (0x20)
#define MCF_GPIO_DDRAN_DDRAN6             (0x40)
#define MCF_GPIO_DDRAN_DDRAN7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRAS */
#define MCF_GPIO_DDRAS_DDRAS0             (0x01)
#define MCF_GPIO_DDRAS_DDRAS1             (0x02)
#define MCF_GPIO_DDRAS_DDRAS2             (0x04)
#define MCF_GPIO_DDRAS_DDRAS3             (0x08)
#define MCF_GPIO_DDRAS_DDRAS4             (0x10)
#define MCF_GPIO_DDRAS_DDRAS5             (0x20)
#define MCF_GPIO_DDRAS_DDRAS6             (0x40)
#define MCF_GPIO_DDRAS_DDRAS7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRQS */
#define MCF_GPIO_DDRQS_DDRQS0             (0x01)
#define MCF_GPIO_DDRQS_DDRQS1             (0x02)
#define MCF_GPIO_DDRQS_DDRQS2             (0x04)
#define MCF_GPIO_DDRQS_DDRQS3             (0x08)
#define MCF_GPIO_DDRQS_DDRQS4             (0x10)
#define MCF_GPIO_DDRQS_DDRQS5             (0x20)
#define MCF_GPIO_DDRQS_DDRQS6             (0x40)
#define MCF_GPIO_DDRQS_DDRQS7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRTA */
#define MCF_GPIO_DDRTA_DDRTA0             (0x01)
#define MCF_GPIO_DDRTA_DDRTA1             (0x02)
#define MCF_GPIO_DDRTA_DDRTA2             (0x04)
#define MCF_GPIO_DDRTA_DDRTA3             (0x08)
#define MCF_GPIO_DDRTA_DDRTA4             (0x10)
#define MCF_GPIO_DDRTA_DDRTA5             (0x20)
#define MCF_GPIO_DDRTA_DDRTA6             (0x40)
#define MCF_GPIO_DDRTA_DDRTA7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRTC */
#define MCF_GPIO_DDRTC_DDRTC0             (0x01)
#define MCF_GPIO_DDRTC_DDRTC1             (0x02)
#define MCF_GPIO_DDRTC_DDRTC2             (0x04)
#define MCF_GPIO_DDRTC_DDRTC3             (0x08)
#define MCF_GPIO_DDRTC_DDRTC4             (0x10)
#define MCF_GPIO_DDRTC_DDRTC5             (0x20)
#define MCF_GPIO_DDRTC_DDRTC6             (0x40)
#define MCF_GPIO_DDRTC_DDRTC7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRUA */
#define MCF_GPIO_DDRUA_DDRUA0             (0x01)
#define MCF_GPIO_DDRUA_DDRUA1             (0x02)
#define MCF_GPIO_DDRUA_DDRUA2             (0x04)
#define MCF_GPIO_DDRUA_DDRUA3             (0x08)
#define MCF_GPIO_DDRUA_DDRUA4             (0x10)
#define MCF_GPIO_DDRUA_DDRUA5             (0x20)
#define MCF_GPIO_DDRUA_DDRUA6             (0x40)
#define MCF_GPIO_DDRUA_DDRUA7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRUB */
#define MCF_GPIO_DDRUB_DDRUB0             (0x01)
#define MCF_GPIO_DDRUB_DDRUB1             (0x02)
#define MCF_GPIO_DDRUB_DDRUB2             (0x04)
#define MCF_GPIO_DDRUB_DDRUB3             (0x08)
#define MCF_GPIO_DDRUB_DDRUB4             (0x10)
#define MCF_GPIO_DDRUB_DDRUB5             (0x20)
#define MCF_GPIO_DDRUB_DDRUB6             (0x40)
#define MCF_GPIO_DDRUB_DDRUB7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRUC */
#define MCF_GPIO_DDRUC_DDRUC0             (0x01)
#define MCF_GPIO_DDRUC_DDRUC1             (0x02)
#define MCF_GPIO_DDRUC_DDRUC2             (0x04)
#define MCF_GPIO_DDRUC_DDRUC3             (0x08)
#define MCF_GPIO_DDRUC_DDRUC4             (0x10)
#define MCF_GPIO_DDRUC_DDRUC5             (0x20)
#define MCF_GPIO_DDRUC_DDRUC6             (0x40)
#define MCF_GPIO_DDRUC_DDRUC7             (0x80)

/* Bit definitions and macros for MCF_GPIO_DDRDD */
#define MCF_GPIO_DDRDD_DDRDD0             (0x01)
#define MCF_GPIO_DDRDD_DDRDD1             (0x02)
#define MCF_GPIO_DDRDD_DDRDD2             (0x04)
#define MCF_GPIO_DDRDD_DDRDD3             (0x08)
#define MCF_GPIO_DDRDD_DDRDD4             (0x10)
#define MCF_GPIO_DDRDD_DDRDD5             (0x20)
#define MCF_GPIO_DDRDD_DDRDD6             (0x40)
#define MCF_GPIO_DDRDD_DDRDD7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETNQ */
#define MCF_GPIO_SETNQ_SETNQ0             (0x01)
#define MCF_GPIO_SETNQ_SETNQ1             (0x02)
#define MCF_GPIO_SETNQ_SETNQ2             (0x04)
#define MCF_GPIO_SETNQ_SETNQ3             (0x08)
#define MCF_GPIO_SETNQ_SETNQ4             (0x10)
#define MCF_GPIO_SETNQ_SETNQ5             (0x20)
#define MCF_GPIO_SETNQ_SETNQ6             (0x40)
#define MCF_GPIO_SETNQ_SETNQ7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETAN */
#define MCF_GPIO_SETAN_SETAN0             (0x01)
#define MCF_GPIO_SETAN_SETAN1             (0x02)
#define MCF_GPIO_SETAN_SETAN2             (0x04)
#define MCF_GPIO_SETAN_SETAN3             (0x08)
#define MCF_GPIO_SETAN_SETAN4             (0x10)
#define MCF_GPIO_SETAN_SETAN5             (0x20)
#define MCF_GPIO_SETAN_SETAN6             (0x40)
#define MCF_GPIO_SETAN_SETAN7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETAS */
#define MCF_GPIO_SETAS_SETAS0             (0x01)
#define MCF_GPIO_SETAS_SETAS1             (0x02)
#define MCF_GPIO_SETAS_SETAS2             (0x04)
#define MCF_GPIO_SETAS_SETAS3             (0x08)
#define MCF_GPIO_SETAS_SETAS4             (0x10)
#define MCF_GPIO_SETAS_SETAS5             (0x20)
#define MCF_GPIO_SETAS_SETAS6             (0x40)
#define MCF_GPIO_SETAS_SETAS7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETQS */
#define MCF_GPIO_SETQS_SETQS0             (0x01)
#define MCF_GPIO_SETQS_SETQS1             (0x02)
#define MCF_GPIO_SETQS_SETQS2             (0x04)
#define MCF_GPIO_SETQS_SETQS3             (0x08)
#define MCF_GPIO_SETQS_SETQS4             (0x10)
#define MCF_GPIO_SETQS_SETQS5             (0x20)
#define MCF_GPIO_SETQS_SETQS6             (0x40)
#define MCF_GPIO_SETQS_SETQS7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETTA */
#define MCF_GPIO_SETTA_SETTA0             (0x01)
#define MCF_GPIO_SETTA_SETTA1             (0x02)
#define MCF_GPIO_SETTA_SETTA2             (0x04)
#define MCF_GPIO_SETTA_SETTA3             (0x08)
#define MCF_GPIO_SETTA_SETTA4             (0x10)
#define MCF_GPIO_SETTA_SETTA5             (0x20)
#define MCF_GPIO_SETTA_SETTA6             (0x40)
#define MCF_GPIO_SETTA_SETTA7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETTC */
#define MCF_GPIO_SETTC_SETTC0             (0x01)
#define MCF_GPIO_SETTC_SETTC1             (0x02)
#define MCF_GPIO_SETTC_SETTC2             (0x04)
#define MCF_GPIO_SETTC_SETTC3             (0x08)
#define MCF_GPIO_SETTC_SETTC4             (0x10)
#define MCF_GPIO_SETTC_SETTC5             (0x20)
#define MCF_GPIO_SETTC_SETTC6             (0x40)
#define MCF_GPIO_SETTC_SETTC7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETUA */
#define MCF_GPIO_SETUA_SETUA0             (0x01)
#define MCF_GPIO_SETUA_SETUA1             (0x02)
#define MCF_GPIO_SETUA_SETUA2             (0x04)
#define MCF_GPIO_SETUA_SETUA3             (0x08)
#define MCF_GPIO_SETUA_SETUA4             (0x10)
#define MCF_GPIO_SETUA_SETUA5             (0x20)
#define MCF_GPIO_SETUA_SETUA6             (0x40)
#define MCF_GPIO_SETUA_SETUA7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETUB */
#define MCF_GPIO_SETUB_SETUB0             (0x01)
#define MCF_GPIO_SETUB_SETUB1             (0x02)
#define MCF_GPIO_SETUB_SETUB2             (0x04)
#define MCF_GPIO_SETUB_SETUB3             (0x08)
#define MCF_GPIO_SETUB_SETUB4             (0x10)
#define MCF_GPIO_SETUB_SETUB5             (0x20)
#define MCF_GPIO_SETUB_SETUB6             (0x40)
#define MCF_GPIO_SETUB_SETUB7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETUC */
#define MCF_GPIO_SETUC_SETUC0             (0x01)
#define MCF_GPIO_SETUC_SETUC1             (0x02)
#define MCF_GPIO_SETUC_SETUC2             (0x04)
#define MCF_GPIO_SETUC_SETUC3             (0x08)
#define MCF_GPIO_SETUC_SETUC4             (0x10)
#define MCF_GPIO_SETUC_SETUC5             (0x20)
#define MCF_GPIO_SETUC_SETUC6             (0x40)
#define MCF_GPIO_SETUC_SETUC7             (0x80)

/* Bit definitions and macros for MCF_GPIO_SETDD */
#define MCF_GPIO_SETDD_SETDD0             (0x01)
#define MCF_GPIO_SETDD_SETDD1             (0x02)
#define MCF_GPIO_SETDD_SETDD2             (0x04)
#define MCF_GPIO_SETDD_SETDD3             (0x08)
#define MCF_GPIO_SETDD_SETDD4             (0x10)
#define MCF_GPIO_SETDD_SETDD5             (0x20)
#define MCF_GPIO_SETDD_SETDD6             (0x40)
#define MCF_GPIO_SETDD_SETDD7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRNQ */
#define MCF_GPIO_CLRNQ_CLRNQ0             (0x01)
#define MCF_GPIO_CLRNQ_CLRNQ1             (0x02)
#define MCF_GPIO_CLRNQ_CLRNQ2             (0x04)
#define MCF_GPIO_CLRNQ_CLRNQ3             (0x08)
#define MCF_GPIO_CLRNQ_CLRNQ4             (0x10)
#define MCF_GPIO_CLRNQ_CLRNQ5             (0x20)
#define MCF_GPIO_CLRNQ_CLRNQ6             (0x40)
#define MCF_GPIO_CLRNQ_CLRNQ7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRAN */
#define MCF_GPIO_CLRAN_CLRAN0             (0x01)
#define MCF_GPIO_CLRAN_CLRAN1             (0x02)
#define MCF_GPIO_CLRAN_CLRAN2             (0x04)
#define MCF_GPIO_CLRAN_CLRAN3             (0x08)
#define MCF_GPIO_CLRAN_CLRAN4             (0x10)
#define MCF_GPIO_CLRAN_CLRAN5             (0x20)
#define MCF_GPIO_CLRAN_CLRAN6             (0x40)
#define MCF_GPIO_CLRAN_CLRAN7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRAS */
#define MCF_GPIO_CLRAS_CLRAS0             (0x01)
#define MCF_GPIO_CLRAS_CLRAS1             (0x02)
#define MCF_GPIO_CLRAS_CLRAS2             (0x04)
#define MCF_GPIO_CLRAS_CLRAS3             (0x08)
#define MCF_GPIO_CLRAS_CLRAS4             (0x10)
#define MCF_GPIO_CLRAS_CLRAS5             (0x20)
#define MCF_GPIO_CLRAS_CLRAS6             (0x40)
#define MCF_GPIO_CLRAS_CLRAS7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRQS */
#define MCF_GPIO_CLRQS_CLRQS0             (0x01)
#define MCF_GPIO_CLRQS_CLRQS1             (0x02)
#define MCF_GPIO_CLRQS_CLRQS2             (0x04)
#define MCF_GPIO_CLRQS_CLRQS3             (0x08)
#define MCF_GPIO_CLRQS_CLRQS4             (0x10)
#define MCF_GPIO_CLRQS_CLRQS5             (0x20)
#define MCF_GPIO_CLRQS_CLRQS6             (0x40)
#define MCF_GPIO_CLRQS_CLRQS7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRTA */
#define MCF_GPIO_CLRTA_CLRTA0             (0x01)
#define MCF_GPIO_CLRTA_CLRTA1             (0x02)
#define MCF_GPIO_CLRTA_CLRTA2             (0x04)
#define MCF_GPIO_CLRTA_CLRTA3             (0x08)
#define MCF_GPIO_CLRTA_CLRTA4             (0x10)
#define MCF_GPIO_CLRTA_CLRTA5             (0x20)
#define MCF_GPIO_CLRTA_CLRTA6             (0x40)
#define MCF_GPIO_CLRTA_CLRTA7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRTC */
#define MCF_GPIO_CLRTC_CLRTC0             (0x01)
#define MCF_GPIO_CLRTC_CLRTC1             (0x02)
#define MCF_GPIO_CLRTC_CLRTC2             (0x04)
#define MCF_GPIO_CLRTC_CLRTC3             (0x08)
#define MCF_GPIO_CLRTC_CLRTC4             (0x10)
#define MCF_GPIO_CLRTC_CLRTC5             (0x20)
#define MCF_GPIO_CLRTC_CLRTC6             (0x40)
#define MCF_GPIO_CLRTC_CLRTC7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRUA */
#define MCF_GPIO_CLRUA_CLRUA0             (0x01)
#define MCF_GPIO_CLRUA_CLRUA1             (0x02)
#define MCF_GPIO_CLRUA_CLRUA2             (0x04)
#define MCF_GPIO_CLRUA_CLRUA3             (0x08)
#define MCF_GPIO_CLRUA_CLRUA4             (0x10)
#define MCF_GPIO_CLRUA_CLRUA5             (0x20)
#define MCF_GPIO_CLRUA_CLRUA6             (0x40)
#define MCF_GPIO_CLRUA_CLRUA7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRUB */
#define MCF_GPIO_CLRUB_CLRUB0             (0x01)
#define MCF_GPIO_CLRUB_CLRUB1             (0x02)
#define MCF_GPIO_CLRUB_CLRUB2             (0x04)
#define MCF_GPIO_CLRUB_CLRUB3             (0x08)
#define MCF_GPIO_CLRUB_CLRUB4             (0x10)
#define MCF_GPIO_CLRUB_CLRUB5             (0x20)
#define MCF_GPIO_CLRUB_CLRUB6             (0x40)
#define MCF_GPIO_CLRUB_CLRUB7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRUC */
#define MCF_GPIO_CLRUC_CLRUC0             (0x01)
#define MCF_GPIO_CLRUC_CLRUC1             (0x02)
#define MCF_GPIO_CLRUC_CLRUC2             (0x04)
#define MCF_GPIO_CLRUC_CLRUC3             (0x08)
#define MCF_GPIO_CLRUC_CLRUC4             (0x10)
#define MCF_GPIO_CLRUC_CLRUC5             (0x20)
#define MCF_GPIO_CLRUC_CLRUC6             (0x40)
#define MCF_GPIO_CLRUC_CLRUC7             (0x80)

/* Bit definitions and macros for MCF_GPIO_CLRDD */
#define MCF_GPIO_CLRDD_CLRDD0             (0x01)
#define MCF_GPIO_CLRDD_CLRDD1             (0x02)
#define MCF_GPIO_CLRDD_CLRDD2             (0x04)
#define MCF_GPIO_CLRDD_CLRDD3             (0x08)
#define MCF_GPIO_CLRDD_CLRDD4             (0x10)
#define MCF_GPIO_CLRDD_CLRDD5             (0x20)
#define MCF_GPIO_CLRDD_CLRDD6             (0x40)
#define MCF_GPIO_CLRDD_CLRDD7             (0x80)

/* Bit definitions and macros for MCF_GPIO_PNQPAR */
#define MCF_GPIO_PNQPAR_PNQPAR1(x)        (((x)&0x0003)<<2)
#define MCF_GPIO_PNQPAR_PNQPAR2(x)        (((x)&0x0003)<<4)
#define MCF_GPIO_PNQPAR_PNQPAR3(x)        (((x)&0x0003)<<6)
#define MCF_GPIO_PNQPAR_PNQPAR4(x)        (((x)&0x0003)<<8)
#define MCF_GPIO_PNQPAR_PNQPAR5(x)        (((x)&0x0003)<<10)
#define MCF_GPIO_PNQPAR_PNQPAR6(x)        (((x)&0x0003)<<12)
#define MCF_GPIO_PNQPAR_PNQPAR7(x)        (((x)&0x0003)<<14)
#define MCF_GPIO_PNQPAR_IRQ1_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ2_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ3_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ4_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ5_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ6_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ7_GPIO         (0x0000)
#define MCF_GPIO_PNQPAR_IRQ1_IRQ1         (0x0004)
#define MCF_GPIO_PNQPAR_IRQ2_IRQ2         (0x0010)
#define MCF_GPIO_PNQPAR_IRQ3_IRQ3         (0x0040)
#define MCF_GPIO_PNQPAR_IRQ4_IRQ4         (0x0100)
#define MCF_GPIO_PNQPAR_IRQ5_IRQ5         (0x0400)
#define MCF_GPIO_PNQPAR_IRQ6_IRQ6         (0x1000)
#define MCF_GPIO_PNQPAR_IRQ7_IRQ7         (0x4000)
#define MCF_GPIO_PNQPAR_IRQ1_SYNCA        (0x0008)
#define MCF_GPIO_PNQPAR_IRQ1_USB_ALT_CLK  (0x000C)
#define MCF_GPIO_PNQPAR_IRQ2_USB_SESSVLD  (0x0020)
#define MCF_GPIO_PNQPAR_IRQ3_USB_SESSEND  (0x0080)
#define MCF_GPIO_PNQPAR_IRQ4_USB_PULLUP   (0x0200)
#define MCF_GPIO_PNQPAR_IRQ5_USB_VBUSVLD  (0x0800)
#define MCF_GPIO_PNQPAR_IRQ6_USB_ID       (0x2000)

/* Bit definitions and macros for MCF_GPIO_PANPAR */
#define MCF_GPIO_PANPAR_PANPAR0           (0x01)
#define MCF_GPIO_PANPAR_PANPAR1           (0x02)
#define MCF_GPIO_PANPAR_PANPAR2           (0x04)
#define MCF_GPIO_PANPAR_PANPAR3           (0x08)
#define MCF_GPIO_PANPAR_PANPAR4           (0x10)
#define MCF_GPIO_PANPAR_PANPAR5           (0x20)
#define MCF_GPIO_PANPAR_PANPAR6           (0x40)
#define MCF_GPIO_PANPAR_PANPAR7           (0x80)
#define MCF_GPIO_PANPAR_AN0_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN1_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN2_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN3_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN4_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN5_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN6_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN7_GPIO          (0x00)
#define MCF_GPIO_PANPAR_AN0_AN0           (0x02)
#define MCF_GPIO_PANPAR_AN1_AN1           (0x03)
#define MCF_GPIO_PANPAR_AN2_AN2           (0x04)
#define MCF_GPIO_PANPAR_AN3_AN3           (0x08)
#define MCF_GPIO_PANPAR_AN4_AN4           (0x10)
#define MCF_GPIO_PANPAR_AN5_AN5           (0x20)
#define MCF_GPIO_PANPAR_AN6_AN6           (0x40)
#define MCF_GPIO_PANPAR_AN7_AN7           (0x80)

/* Bit definitions and macros for MCF_GPIO_PASPAR */
#define MCF_GPIO_PASPAR_PASPAR0(x)        (((x)&0x03)<<0)
#define MCF_GPIO_PASPAR_PASPAR1(x)        (((x)&0x03)<<2)
#define MCF_GPIO_PASPAR_PASPAR2(x)        (((x)&0x03)<<4)
#define MCF_GPIO_PASPAR_PASPAR3(x)        (((x)&0x03)<<6)
#define MCF_GPIO_PASPAR_SCL_GPIO          (0x00)
#define MCF_GPIO_PASPAR_SDA_GPIO          (0x00)
#define MCF_GPIO_PASPAR_SCL_SCL           (0x01)
#define MCF_GPIO_PASPAR_SDA_SDA           (0x04)
#define MCF_GPIO_PASPAR_SCL_TXD2          (0x03)
#define MCF_GPIO_PASPAR_SDA_RXD2          (0x0c)

/* Bit definitions and macros for MCF_GPIO_PQSPAR */
#define MCF_GPIO_PQSPAR_PQSPAR0(x)        (((x)&0x0003)<<0)
#define MCF_GPIO_PQSPAR_PQSPAR1(x)        (((x)&0x0003)<<2)
#define MCF_GPIO_PQSPAR_PQSPAR2(x)        (((x)&0x0003)<<4)
#define MCF_GPIO_PQSPAR_PQSPAR3(x)        (((x)&0x0003)<<6)
#define MCF_GPIO_PQSPAR_PQSPAR4(x)        (((x)&0x0003)<<8)
#define MCF_GPIO_PQSPAR_PQSPAR5(x)        (((x)&0x0003)<<10)
#define MCF_GPIO_PQSPAR_PQSPAR6(x)        (((x)&0x0003)<<12)
#define MCF_GPIO_PQSPAR_DOUT_GPIO         (0x0000)
#define MCF_GPIO_PQSPAR_DIN_GPIO          (0x0000)
#define MCF_GPIO_PQSPAR_SCK_GPIO          (0x0000)
#define MCF_GPIO_PQSPAR_CS0_GPIO          (0x0000)
#define MCF_GPIO_PQSPAR_CS1_GPIO          (0x0000)
#define MCF_GPIO_PQSPAR_CS2_GPIO          (0x0000)
#define MCF_GPIO_PQSPAR_CS3_GPIO          (0x0000)
#define MCF_GPIO_PQSPAR_DOUT_DOUT         (0x0001)
#define MCF_GPIO_PQSPAR_DIN_DIN           (0x0004)
#define MCF_GPIO_PQSPAR_SCK_SCK           (0x0010)
#define MCF_GPIO_PQSPAR_CS0_CS0           (0x0040)
#define MCF_GPIO_PQSPAR_CS1_CS1           (0x0100)
#define MCF_GPIO_PQSPAR_CS2_CS2           (0x0400)
#define MCF_GPIO_PQSPAR_CS3_CS3           (0x1000)
#define MCF_GPIO_PQSPAR_SCK_SCL           (0x0020)
#define MCF_GPIO_PQSPAR_CS0_SDA           (0x0080)
#define MCF_GPIO_PQSPAR_CS3_SYNCA         (0x2000)
#define MCF_GPIO_PQSPAR_DOUT_TXD1         (0x0003)
#define MCF_GPIO_PQSPAR_DIN_RXD1          (0x000C)
#define MCF_GPIO_PQSPAR_SCK_RTS1          (0x0030)
#define MCF_GPIO_PQSPAR_CS0_CTS1          (0x00C0)
#define MCF_GPIO_PQSPAR_CS3_USB_DP_PD     (0xc000)
#define MCF_GPIO_PQSPAR_CS2_USB_DM_PD     (0x0800)
#define MCF_GPIO_PQSPAR_CS1_USB_PULLUP    (0x0200)

/* Bit definitions and macros for MCF_GPIO_PTAPAR */
#define MCF_GPIO_PTAPAR_PTAPAR0(x)        (((x)&0x03)<<0)
#define MCF_GPIO_PTAPAR_PTAPAR1(x)        (((x)&0x03)<<2)
#define MCF_GPIO_PTAPAR_PTAPAR2(x)        (((x)&0x03)<<4)
#define MCF_GPIO_PTAPAR_PTAPAR3(x)        (((x)&0x03)<<6)
#define MCF_GPIO_PTAPAR_ICOC0_GPIO        (0x00)
#define MCF_GPIO_PTAPAR_ICOC1_GPIO        (0x00)
#define MCF_GPIO_PTAPAR_ICOC2_GPIO        (0x00)
#define MCF_GPIO_PTAPAR_ICOC3_GPIO        (0x00)
#define MCF_GPIO_PTAPAR_ICOC0_ICOC0       (0x01)
#define MCF_GPIO_PTAPAR_ICOC1_ICOC1       (0x04)
#define MCF_GPIO_PTAPAR_ICOC2_ICOC2       (0x10)
#define MCF_GPIO_PTAPAR_ICOC3_ICOC3       (0x40)
#define MCF_GPIO_PTAPAR_ICOC0_PWM1        (0x02)
#define MCF_GPIO_PTAPAR_ICOC1_PWM3        (0x08)
#define MCF_GPIO_PTAPAR_ICOC2_PWM5        (0x20)
#define MCF_GPIO_PTAPAR_ICOC3_PWM7        (0x80)

/* Bit definitions and macros for MCF_GPIO_PTCPAR */
#define MCF_GPIO_PTCPAR_PTCPAR0(x)        (((x)&0x03)<<0)
#define MCF_GPIO_PTCPAR_PTCPAR1(x)        (((x)&0x03)<<2)
#define MCF_GPIO_PTCPAR_PTCPAR2(x)        (((x)&0x03)<<4)
#define MCF_GPIO_PTCPAR_PTCPAR3(x)        (((x)&0x03)<<6)
#define MCF_GPIO_PTCPAR_TIN0_GPIO         (0x00)
#define MCF_GPIO_PTCPAR_TIN1_GPIO         (0x00)
#define MCF_GPIO_PTCPAR_TIN2_GPIO         (0x00)
#define MCF_GPIO_PTCPAR_TIN3_GPIO         (0x00)
#define MCF_GPIO_PTCPAR_TIN0_TIN0         (0x01)
#define MCF_GPIO_PTCPAR_TIN1_TIN1         (0x04)
#define MCF_GPIO_PTCPAR_TIN2_TIN2         (0x10)
#define MCF_GPIO_PTCPAR_TIN3_TIN3         (0x40)
#define MCF_GPIO_PTCPAR_TIN0_TOUT0        (0x02)
#define MCF_GPIO_PTCPAR_TIN1_TOUT1        (0x08)
#define MCF_GPIO_PTCPAR_TIN2_TOUT2        (0x20)
#define MCF_GPIO_PTCPAR_TIN3_TOUT3        (0x80)
#define MCF_GPIO_PTCPAR_TIN0_PWM0         (0x03)
#define MCF_GPIO_PTCPAR_TIN1_PWM2         (0x0C)
#define MCF_GPIO_PTCPAR_TIN2_PWM4         (0x30)
#define MCF_GPIO_PTCPAR_TIN3_PWM6         (0xC0)

/* Bit definitions and macros for MCF_GPIO_PUAPAR */
#define MCF_GPIO_PUAPAR_PUAPAR0(x)        (((x)&0x03)<<0)
#define MCF_GPIO_PUAPAR_PUAPAR1(x)        (((x)&0x03)<<2)
#define MCF_GPIO_PUAPAR_PUAPAR2(x)        (((x)&0x03)<<4)
#define MCF_GPIO_PUAPAR_PUAPAR3(x)        (((x)&0x03)<<6)
#define MCF_GPIO_PUAPAR_TXD0_GPIO         (0x00)
#define MCF_GPIO_PUAPAR_RXD0_GPIO         (0x00)
#define MCF_GPIO_PUAPAR_RTS0_GPIO         (0x00)
#define MCF_GPIO_PUAPAR_CTS0_GPIO         (0x00)
#define MCF_GPIO_PUAPAR_TXD0_TXD0         (0x01)
#define MCF_GPIO_PUAPAR_RXD0_RXD0         (0x04)
#define MCF_GPIO_PUAPAR_RTS0_RTS0         (0x10)
#define MCF_GPIO_PUAPAR_CTS0_CTS0         (0x40)
#define MCF_GPIO_PUAPAR_RTS0_USB_VBUSD    (0x20)
#define MCF_GPIO_PUAPAR_CTS0_USB_VBUSE    (0x80)

/* Bit definitions and macros for MCF_GPIO_PUBPAR */
#define MCF_GPIO_PUBPAR_PUBPAR0(x)        (((x)&0x03)<<0)
#define MCF_GPIO_PUBPAR_PUBPAR1(x)        (((x)&0x03)<<2)
#define MCF_GPIO_PUBPAR_PUBPAR2(x)        (((x)&0x03)<<4)
#define MCF_GPIO_PUBPAR_PUBPAR3(x)        (((x)&0x03)<<6)
#define MCF_GPIO_PUBPAR_TXD1_GPIO         (0x00)
#define MCF_GPIO_PUBPAR_RXD1_GPIO         (0x00)
#define MCF_GPIO_PUBPAR_RTS1_GPIO         (0x00)
#define MCF_GPIO_PUBPAR_CTS1_GPIO         (0x00)
#define MCF_GPIO_PUBPAR_TXD1_TXD1         (0x01)
#define MCF_GPIO_PUBPAR_RXD1_RXD1         (0x04)
#define MCF_GPIO_PUBPAR_RTS1_RTS1         (0x10)
#define MCF_GPIO_PUBPAR_CTS1_CTS1         (0x40)
#define MCF_GPIO_PUBPAR_RTS1_SYNCB        (0x20)
#define MCF_GPIO_PUBPAR_CTS1_SYNCA        (0x80)
#define MCF_GPIO_PUBPAR_RTS1_TXD2         (0x30)
#define MCF_GPIO_PUBPAR_CTS1_RXD2         (0xC0)

/* Bit definitions and macros for MCF_GPIO_PUCPAR */
#define MCF_GPIO_PUCPAR_PUCPAR0           (0x01)
#define MCF_GPIO_PUCPAR_PUCPAR1           (0x02)
#define MCF_GPIO_PUCPAR_PUCPAR2           (0x04)
#define MCF_GPIO_PUCPAR_PUCPAR3           (0x08)
#define MCF_GPIO_PUCPAR_TXD2_GPIO         (0x00)
#define MCF_GPIO_PUCPAR_RXD2_GPIO         (0x00)
#define MCF_GPIO_PUCPAR_RTS2_GPIO         (0x00)
#define MCF_GPIO_PUCPAR_CTS2_GPIO         (0x00)
#define MCF_GPIO_PUCPAR_TXD2_TXD2         (0x01)
#define MCF_GPIO_PUCPAR_RXD2_RXD2         (0x04)
#define MCF_GPIO_PUCPAR_RTS2_RTS2         (0x10)
#define MCF_GPIO_PUCPAR_CTS2_CTS2         (0x40)
#define MCF_GPIO_PUCPAR_RTS2_USB_VBUSDIS  (0x02)
#define MCF_GPIO_PUCPAR_CTS2_USB_VBUSCHG  (0x08)

/* Bit definitions and macros for MCF_GPIO_PDDPAR */
#define MCF_GPIO_PDDPAR_PDDPAR0           (0x01)
#define MCF_GPIO_PDDPAR_PDDPAR1           (0x02)
#define MCF_GPIO_PDDPAR_PDDPAR2           (0x04)
#define MCF_GPIO_PDDPAR_PDDPAR3           (0x08)
#define MCF_GPIO_PDDPAR_PDDPAR4           (0x10)
#define MCF_GPIO_PDDPAR_PDDPAR5           (0x20)
#define MCF_GPIO_PDDPAR_PDDPAR6           (0x40)
#define MCF_GPIO_PDDPAR_PDDPAR7           (0x80)
#define MCF_GPIO_PDDPAR_PDD0_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD1_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD2_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD3_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD4_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD5_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD6_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD7_GPIO         (0x00)
#define MCF_GPIO_PDDPAR_PDD0_PST0         (0x01)
#define MCF_GPIO_PDDPAR_PDD1_PST1         (0x02)
#define MCF_GPIO_PDDPAR_PDD2_PST2         (0x04)
#define MCF_GPIO_PDDPAR_PDD3_PST3         (0x08)
#define MCF_GPIO_PDDPAR_PDD4_DDATA0       (0x10)
#define MCF_GPIO_PDDPAR_PDD5_DDATA1       (0x20)
#define MCF_GPIO_PDDPAR_PDD6_DDATA2       (0x40)
#define MCF_GPIO_PDDPAR_PDD7_DDATA3       (0x80)

/* Bit definitions and macros for MCF_GPIO_PSSR */
#define MCF_GPIO_PSSR_PSSR0               (0x00000001)
#define MCF_GPIO_PSSR_PSSR1               (0x00000002)
#define MCF_GPIO_PSSR_PSSR2               (0x00000004)
#define MCF_GPIO_PSSR_PSSR3               (0x00000008)
#define MCF_GPIO_PSSR_PSSR4               (0x00000010)
#define MCF_GPIO_PSSR_PSSR5               (0x00000020)
#define MCF_GPIO_PSSR_PSSR6               (0x00000040)
#define MCF_GPIO_PSSR_PSSR7               (0x00000080)
#define MCF_GPIO_PSSR_PSSR8               (0x00000100)
#define MCF_GPIO_PSSR_PSSR9               (0x00000200)
#define MCF_GPIO_PSSR_PSSR10              (0x00000400)
#define MCF_GPIO_PSSR_PSSR11              (0x00000800)
#define MCF_GPIO_PSSR_PSSR12              (0x00001000)
#define MCF_GPIO_PSSR_PSSR13              (0x00002000)
#define MCF_GPIO_PSSR_PSSR14              (0x00004000)
#define MCF_GPIO_PSSR_PSSR15              (0x00008000)
#define MCF_GPIO_PSSR_PSSR16              (0x00010000)
#define MCF_GPIO_PSSR_PSSR17              (0x00020000)
#define MCF_GPIO_PSSR_PSSR18              (0x00040000)
#define MCF_GPIO_PSSR_PSSR19              (0x00080000)
#define MCF_GPIO_PSSR_PSSR20              (0x00100000)
#define MCF_GPIO_PSSR_PSSR21              (0x00200000)
#define MCF_GPIO_PSSR_PSSR22              (0x00400000)
#define MCF_GPIO_PSSR_PSSR23              (0x00800000)
#define MCF_GPIO_PSSR_PSSR24              (0x01000000)
#define MCF_GPIO_PSSR_PSSR25              (0x02000000)
#define MCF_GPIO_PSSR_PDSR26              (0x04000000)
#define MCF_GPIO_PSSR_PSSR27              (0x08000000)
#define MCF_GPIO_PSSR_PSSR28              (0x10000000)
#define MCF_GPIO_PSSR_PSSR29              (0x20000000)
#define MCF_GPIO_PSSR_PSSR30              (0x40000000)
#define MCF_GPIO_PSSR_PSSR31              (0x80000000)

/* Bit definitions and macros for MCF_GPIO_PDSR */
#define MCF_GPIO_PDSR_PDSR0               (0x00000001)
#define MCF_GPIO_PDSR_PDSR1               (0x00000002)
#define MCF_GPIO_PDSR_PDSR2               (0x00000004)
#define MCF_GPIO_PDSR_PDSR3               (0x00000008)
#define MCF_GPIO_PDSR_PDSR4               (0x00000010)
#define MCF_GPIO_PDSR_PDSR5               (0x00000020)
#define MCF_GPIO_PDSR_PDSR6               (0x00000040)
#define MCF_GPIO_PDSR_PDSR7               (0x00000080)
#define MCF_GPIO_PDSR_PDSR8               (0x00000100)
#define MCF_GPIO_PDSR_PDSR9               (0x00000200)
#define MCF_GPIO_PDSR_PDSR10              (0x00000400)
#define MCF_GPIO_PDSR_PDSR11              (0x00000800)
#define MCF_GPIO_PDSR_PDSR12              (0x00001000)
#define MCF_GPIO_PDSR_PDSR13              (0x00002000)
#define MCF_GPIO_PDSR_PDSR14              (0x00004000)
#define MCF_GPIO_PDSR_PDSR15              (0x00008000)
#define MCF_GPIO_PDSR_PDSR16              (0x00010000)
#define MCF_GPIO_PDSR_PDSR17              (0x00020000)
#define MCF_GPIO_PDSR_PDSR18              (0x00040000)
#define MCF_GPIO_PDSR_PDSR19              (0x00080000)
#define MCF_GPIO_PDSR_PDSR20              (0x00100000)
#define MCF_GPIO_PDSR_PDSR21              (0x00200000)
#define MCF_GPIO_PDSR_PDSR22              (0x00400000)
#define MCF_GPIO_PDSR_PDSR23              (0x00800000)
#define MCF_GPIO_PDSR_PDSR24              (0x01000000)
#define MCF_GPIO_PDSR_PDSR25              (0x02000000)
#define MCF_GPIO_PDSR_PDSR26              (0x04000000)
#define MCF_GPIO_PDSR_PDSR27              (0x08000000)
#define MCF_GPIO_PDSR_PDSR28              (0x10000000)
#define MCF_GPIO_PDSR_PDSR29              (0x20000000)
#define MCF_GPIO_PDSR_PDSR30              (0x40000000)
#define MCF_GPIO_PDSR_PDSR31              (0x80000000)

/*********************************************************************
*
* I2C Module (I2C)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_I2C_I2AR          (*(hcc_reg8 *)(&_IPSBAR[0x000300]))
#define MCF_I2C_I2FDR         (*(hcc_reg8 *)(&_IPSBAR[0x000304]))
#define MCF_I2C_I2CR          (*(hcc_reg8 *)(&_IPSBAR[0x000308]))
#define MCF_I2C_I2SR          (*(hcc_reg8 *)(&_IPSBAR[0x00030C]))
#define MCF_I2C_I2DR          (*(hcc_reg8 *)(&_IPSBAR[0x000310]))

/* Bit definitions and macros for MCF_I2C_I2AR */
#define MCF_I2C_I2AR_ADR(x)   (((x)&0x7F)<<1)

/* Bit definitions and macros for MCF_I2C_I2FDR */
#define MCF_I2C_I2FDR_IC(x)   (((x)&0x3F)<<0)

/* Bit definitions and macros for MCF_I2C_I2CR */
#define MCF_I2C_I2CR_RSTA     (0x04)
#define MCF_I2C_I2CR_TXAK     (0x08)
#define MCF_I2C_I2CR_MTX      (0x10)
#define MCF_I2C_I2CR_MSTA     (0x20)
#define MCF_I2C_I2CR_IIEN     (0x40)
#define MCF_I2C_I2CR_IEN      (0x80)

/* Bit definitions and macros for MCF_I2C_I2SR */
#define MCF_I2C_I2SR_RXAK     (0x01)
#define MCF_I2C_I2SR_IIF      (0x02)
#define MCF_I2C_I2SR_SRW      (0x04)
#define MCF_I2C_I2SR_IAL      (0x10)
#define MCF_I2C_I2SR_IBB      (0x20)
#define MCF_I2C_I2SR_IAAS     (0x40)
#define MCF_I2C_I2SR_ICF      (0x80)

/* Bit definitions and macros for MCF_I2C_I2DR */
#define MCF_I2C_I2DR_DATA(x)  (((x)&0xFF)<<0)

/*********************************************************************
*
* Edge Port Module (EPORT)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_EPORT_EPPAR0                (*(hcc_reg16*)(&_IPSBAR[0x130000]))
#define MCF_EPORT_EPPAR1                (*(hcc_reg16*)(&_IPSBAR[0x140000]))
#define MCF_EPORT_EPDDR0                (*(hcc_reg8 *)(&_IPSBAR[0x130002]))
#define MCF_EPORT_EPDDR1                (*(hcc_reg8 *)(&_IPSBAR[0x140002]))
#define MCF_EPORT_EPIER0                (*(hcc_reg8 *)(&_IPSBAR[0x130003]))
#define MCF_EPORT_EPIER1                (*(hcc_reg8 *)(&_IPSBAR[0x140003]))
#define MCF_EPORT_EPDR0                 (*(hcc_reg8 *)(&_IPSBAR[0x130004]))
#define MCF_EPORT_EPDR1                 (*(hcc_reg8 *)(&_IPSBAR[0x140004]))
#define MCF_EPORT_EPPDR0                (*(hcc_reg8 *)(&_IPSBAR[0x130005]))
#define MCF_EPORT_EPPDR1                (*(hcc_reg8 *)(&_IPSBAR[0x140005]))
#define MCF_EPORT_EPFR0                 (*(hcc_reg8 *)(&_IPSBAR[0x130006]))
#define MCF_EPORT_EPFR1                 (*(hcc_reg8 *)(&_IPSBAR[0x140006]))

/* Bit definitions and macros for MCF_EPORT_EPPAR */
#define MCF_EPORT_EPPAR_EPPA1(x)        (((x)&0x0003)<<2)
#define MCF_EPORT_EPPAR_EPPA2(x)        (((x)&0x0003)<<4)
#define MCF_EPORT_EPPAR_EPPA3(x)        (((x)&0x0003)<<6)
#define MCF_EPORT_EPPAR_EPPA4(x)        (((x)&0x0003)<<8)
#define MCF_EPORT_EPPAR_EPPA5(x)        (((x)&0x0003)<<10)
#define MCF_EPORT_EPPAR_EPPA6(x)        (((x)&0x0003)<<12)
#define MCF_EPORT_EPPAR_EPPA7(x)        (((x)&0x0003)<<14)
#define MCF_EPORT_EPPAR_EPPA8(x)        (((x)&0x0003)<<0)
#define MCF_EPORT_EPPAR_EPPA9(x)        (((x)&0x0003)<<2)
#define MCF_EPORT_EPPAR_EPPA10(x)       (((x)&0x0003)<<4)
#define MCF_EPORT_EPPAR_EPPA11(x)       (((x)&0x0003)<<6)
#define MCF_EPORT_EPPAR_EPPA12(x)       (((x)&0x0003)<<8)
#define MCF_EPORT_EPPAR_EPPA13(x)       (((x)&0x0003)<<10)
#define MCF_EPORT_EPPAR_EPPA14(x)       (((x)&0x0003)<<12)
#define MCF_EPORT_EPPAR_EPPA15(x)       (((x)&0x0003)<<14)
#define MCF_EPORT_EPPAR_LEVEL           (0)
#define MCF_EPORT_EPPAR_RISING          (1)
#define MCF_EPORT_EPPAR_FALLING         (2)
#define MCF_EPORT_EPPAR_BOTH            (3)
#define MCF_EPORT_EPPAR_EPPA15_LEVEL    (0x0000)
#define MCF_EPORT_EPPAR_EPPA15_RISING   (0x4000)
#define MCF_EPORT_EPPAR_EPPA15_FALLING  (0x8000)
#define MCF_EPORT_EPPAR_EPPA15_BOTH     (0xC000)
#define MCF_EPORT_EPPAR_EPPA14_LEVEL    (0x0000)
#define MCF_EPORT_EPPAR_EPPA14_RISING   (0x1000)
#define MCF_EPORT_EPPAR_EPPA14_FALLING  (0x2000)
#define MCF_EPORT_EPPAR_EPPA14_BOTH     (0x3000)
#define MCF_EPORT_EPPAR_EPPA13_LEVEL    (0x0000)
#define MCF_EPORT_EPPAR_EPPA13_RISING   (0x0400)
#define MCF_EPORT_EPPAR_EPPA13_FALLING  (0x0800)
#define MCF_EPORT_EPPAR_EPPA13_BOTH     (0x0C00)
#define MCF_EPORT_EPPAR_EPPA12_LEVEL    (0x0000)
#define MCF_EPORT_EPPAR_EPPA12_RISING   (0x0100)
#define MCF_EPORT_EPPAR_EPPA12_FALLING  (0x0200)
#define MCF_EPORT_EPPAR_EPPA12_BOTH     (0x0300)
#define MCF_EPORT_EPPAR_EPPA11_LEVEL    (0x0000)
#define MCF_EPORT_EPPAR_EPPA11_RISING   (0x0040)
#define MCF_EPORT_EPPAR_EPPA11_FALLING  (0x0080)
#define MCF_EPORT_EPPAR_EPPA11_BOTH     (0x00C0)
#define MCF_EPORT_EPPAR_EPPA10_LEVEL    (0x0000)
#define MCF_EPORT_EPPAR_EPPA10_RISING   (0x0010)
#define MCF_EPORT_EPPAR_EPPA10_FALLING  (0x0020)
#define MCF_EPORT_EPPAR_EPPA10_BOTH     (0x0030)
#define MCF_EPORT_EPPAR_EPPA9_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA9_RISING    (0x0004)
#define MCF_EPORT_EPPAR_EPPA9_FALLING   (0x0008)
#define MCF_EPORT_EPPAR_EPPA9_BOTH      (0x000C)
#define MCF_EPORT_EPPAR_EPPA8_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA8_RISING    (0x0001)
#define MCF_EPORT_EPPAR_EPPA8_FALLING   (0x0002)
#define MCF_EPORT_EPPAR_EPPA8_BOTH      (0x0003)
#define MCF_EPORT_EPPAR_EPPA7_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA7_RISING    (0x4000)
#define MCF_EPORT_EPPAR_EPPA7_FALLING   (0x8000)
#define MCF_EPORT_EPPAR_EPPA7_BOTH      (0xC000)
#define MCF_EPORT_EPPAR_EPPA6_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA6_RISING    (0x1000)
#define MCF_EPORT_EPPAR_EPPA6_FALLING   (0x2000)
#define MCF_EPORT_EPPAR_EPPA6_BOTH      (0x3000)
#define MCF_EPORT_EPPAR_EPPA5_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA5_RISING    (0x0400)
#define MCF_EPORT_EPPAR_EPPA5_FALLING   (0x0800)
#define MCF_EPORT_EPPAR_EPPA5_BOTH      (0x0C00)
#define MCF_EPORT_EPPAR_EPPA4_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA4_RISING    (0x0100)
#define MCF_EPORT_EPPAR_EPPA4_FALLING   (0x0200)
#define MCF_EPORT_EPPAR_EPPA4_BOTH      (0x0300)
#define MCF_EPORT_EPPAR_EPPA3_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA3_RISING    (0x0040)
#define MCF_EPORT_EPPAR_EPPA3_FALLING   (0x0080)
#define MCF_EPORT_EPPAR_EPPA3_BOTH      (0x00C0)
#define MCF_EPORT_EPPAR_EPPA2_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA2_RISING    (0x0010)
#define MCF_EPORT_EPPAR_EPPA2_FALLING   (0x0020)
#define MCF_EPORT_EPPAR_EPPA2_BOTH      (0x0030)
#define MCF_EPORT_EPPAR_EPPA1_LEVEL     (0x0000)
#define MCF_EPORT_EPPAR_EPPA1_RISING    (0x0004)
#define MCF_EPORT_EPPAR_EPPA1_FALLING   (0x0008)
#define MCF_EPORT_EPPAR_EPPA1_BOTH      (0x000C)

/* Bit definitions and macros for MCF_EPORT_EPDDR */
#define MCF_EPORT_EPDDR_EPDD1           (0x02)
#define MCF_EPORT_EPDDR_EPDD2           (0x04)
#define MCF_EPORT_EPDDR_EPDD3           (0x08)
#define MCF_EPORT_EPDDR_EPDD4           (0x10)
#define MCF_EPORT_EPDDR_EPDD5           (0x20)
#define MCF_EPORT_EPDDR_EPDD6           (0x40)
#define MCF_EPORT_EPDDR_EPDD7           (0x80)
#define MCF_EPORT_EPDDR_EPDD8           (0x01)
#define MCF_EPORT_EPDDR_EPDD9           (0x02)
#define MCF_EPORT_EPDDR_EPDD10          (0x04)
#define MCF_EPORT_EPDDR_EPDD11          (0x08)
#define MCF_EPORT_EPDDR_EPDD12          (0x10)
#define MCF_EPORT_EPDDR_EPDD13          (0x20)
#define MCF_EPORT_EPDDR_EPDD14          (0x40)
#define MCF_EPORT_EPDDR_EPDD15          (0x80)

/* Bit definitions and macros for MCF_EPORT_EPIER */
#define MCF_EPORT_EPIER_EPIE1           (0x02)
#define MCF_EPORT_EPIER_EPIE2           (0x04)
#define MCF_EPORT_EPIER_EPIE3           (0x08)
#define MCF_EPORT_EPIER_EPIE4           (0x10)
#define MCF_EPORT_EPIER_EPIE5           (0x20)
#define MCF_EPORT_EPIER_EPIE6           (0x40)
#define MCF_EPORT_EPIER_EPIE7           (0x80)
#define MCF_EPORT_EPIER_EPIE8           (0x01)
#define MCF_EPORT_EPIER_EPIE9           (0x02)
#define MCF_EPORT_EPIER_EPIE10          (0x04)
#define MCF_EPORT_EPIER_EPIE11          (0x08)
#define MCF_EPORT_EPIER_EPIE12          (0x10)
#define MCF_EPORT_EPIER_EPIE13          (0x20)
#define MCF_EPORT_EPIER_EPIE14          (0x40)
#define MCF_EPORT_EPIER_EPIE15          (0x80)

/* Bit definitions and macros for MCF_EPORT_EPDR */
#define MCF_EPORT_EPDR_EPD1             (0x02)
#define MCF_EPORT_EPDR_EPD2             (0x04)
#define MCF_EPORT_EPDR_EPD3             (0x08)
#define MCF_EPORT_EPDR_EPD4             (0x10)
#define MCF_EPORT_EPDR_EPD5             (0x20)
#define MCF_EPORT_EPDR_EPD6             (0x40)
#define MCF_EPORT_EPDR_EPD7             (0x80)
#define MCF_EPORT_EPDR_EPD8             (0x01)
#define MCF_EPORT_EPDR_EPD9             (0x02)
#define MCF_EPORT_EPDR_EPD10            (0x04)
#define MCF_EPORT_EPDR_EPD11            (0x08)
#define MCF_EPORT_EPDR_EPD12            (0x10)
#define MCF_EPORT_EPDR_EPD13            (0x20)
#define MCF_EPORT_EPDR_EPD14            (0x40)
#define MCF_EPORT_EPDR_EPD15            (0x80)

/* Bit definitions and macros for MCF_EPORT_EPPDR */
#define MCF_EPORT_EPPDR_EPPD1           (0x02)
#define MCF_EPORT_EPPDR_EPPD2           (0x04)
#define MCF_EPORT_EPPDR_EPPD3           (0x08)
#define MCF_EPORT_EPPDR_EPPD4           (0x10)
#define MCF_EPORT_EPPDR_EPPD5           (0x20)
#define MCF_EPORT_EPPDR_EPPD6           (0x40)
#define MCF_EPORT_EPPDR_EPPD7           (0x80)
#define MCF_EPORT_EPPDR_EPPD8           (0x01)
#define MCF_EPORT_EPPDR_EPPD9           (0x02)
#define MCF_EPORT_EPPDR_EPPD10          (0x04)
#define MCF_EPORT_EPPDR_EPPD11          (0x08)
#define MCF_EPORT_EPPDR_EPPD12          (0x10)
#define MCF_EPORT_EPPDR_EPPD13          (0x20)
#define MCF_EPORT_EPPDR_EPPD14          (0x40)
#define MCF_EPORT_EPPDR_EPPD15          (0x80)

/* Bit definitions and macros for MCF_EPORT_EPFR */
#define MCF_EPORT_EPFR_EPF1             (0x02)
#define MCF_EPORT_EPFR_EPF2             (0x04)
#define MCF_EPORT_EPFR_EPF3             (0x08)
#define MCF_EPORT_EPFR_EPF4             (0x10)
#define MCF_EPORT_EPFR_EPF5             (0x20)
#define MCF_EPORT_EPFR_EPF6             (0x40)
#define MCF_EPORT_EPFR_EPF7             (0x80)
#define MCF_EPORT_EPFR_EPF8             (0x01)
#define MCF_EPORT_EPFR_EPF9             (0x02)
#define MCF_EPORT_EPFR_EPF10            (0x04)
#define MCF_EPORT_EPFR_EPF11            (0x08)
#define MCF_EPORT_EPFR_EPF12            (0x10)
#define MCF_EPORT_EPFR_EPF13            (0x20)
#define MCF_EPORT_EPFR_EPF14            (0x40)
#define MCF_EPORT_EPFR_EPF15            (0x80)

/*********************************************************************
*
* Universal Asynchronous Receiver Transmitter (UART)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_UART0_UMR                 (*(hcc_reg8 *)(&_IPSBAR[0x000200]))
#define MCF_UART0_USR                 (*(hcc_reg8 *)(&_IPSBAR[0x000204]))
#define MCF_UART0_UCSR                (*(hcc_reg8 *)(&_IPSBAR[0x000204]))
#define MCF_UART0_UCR                 (*(hcc_reg8 *)(&_IPSBAR[0x000208]))
#define MCF_UART0_URB                 (*(hcc_reg8 *)(&_IPSBAR[0x00020C]))
#define MCF_UART0_UTB                 (*(hcc_reg8 *)(&_IPSBAR[0x00020C]))
#define MCF_UART0_UIPCR               (*(hcc_reg8 *)(&_IPSBAR[0x000210]))
#define MCF_UART0_UACR                (*(hcc_reg8 *)(&_IPSBAR[0x000210]))
#define MCF_UART0_UISR                (*(hcc_reg8 *)(&_IPSBAR[0x000214]))
#define MCF_UART0_UIMR                (*(hcc_reg8 *)(&_IPSBAR[0x000214]))
#define MCF_UART0_UBG1                (*(hcc_reg8 *)(&_IPSBAR[0x000218]))
#define MCF_UART0_UBG2                (*(hcc_reg8 *)(&_IPSBAR[0x00021C]))
#define MCF_UART0_UIP                 (*(hcc_reg8 *)(&_IPSBAR[0x000234]))
#define MCF_UART0_UOP1                (*(hcc_reg8 *)(&_IPSBAR[0x000238]))
#define MCF_UART0_UOP0                (*(hcc_reg8 *)(&_IPSBAR[0x00023C]))
#define MCF_UART1_UMR                 (*(hcc_reg8 *)(&_IPSBAR[0x000240]))
#define MCF_UART1_USR                 (*(hcc_reg8 *)(&_IPSBAR[0x000244]))
#define MCF_UART1_UCSR                (*(hcc_reg8 *)(&_IPSBAR[0x000244]))
#define MCF_UART1_UCR                 (*(hcc_reg8 *)(&_IPSBAR[0x000248]))
#define MCF_UART1_URB                 (*(hcc_reg8 *)(&_IPSBAR[0x00024C]))
#define MCF_UART1_UTB                 (*(hcc_reg8 *)(&_IPSBAR[0x00024C]))
#define MCF_UART1_UIPCR               (*(hcc_reg8 *)(&_IPSBAR[0x000250]))
#define MCF_UART1_UACR                (*(hcc_reg8 *)(&_IPSBAR[0x000250]))
#define MCF_UART1_UISR                (*(hcc_reg8 *)(&_IPSBAR[0x000254]))
#define MCF_UART1_UIMR                (*(hcc_reg8 *)(&_IPSBAR[0x000254]))
#define MCF_UART1_UBG1                (*(hcc_reg8 *)(&_IPSBAR[0x000258]))
#define MCF_UART1_UBG2                (*(hcc_reg8 *)(&_IPSBAR[0x00025C]))
#define MCF_UART1_UIP                 (*(hcc_reg8 *)(&_IPSBAR[0x000274]))
#define MCF_UART1_UOP1                (*(hcc_reg8 *)(&_IPSBAR[0x000278]))
#define MCF_UART1_UOP0                (*(hcc_reg8 *)(&_IPSBAR[0x00027C]))
#define MCF_UART2_UMR                 (*(hcc_reg8 *)(&_IPSBAR[0x000280]))
#define MCF_UART2_USR                 (*(hcc_reg8 *)(&_IPSBAR[0x000284]))
#define MCF_UART2_UCSR                (*(hcc_reg8 *)(&_IPSBAR[0x000284]))
#define MCF_UART2_UCR                 (*(hcc_reg8 *)(&_IPSBAR[0x000288]))
#define MCF_UART2_URB                 (*(hcc_reg8 *)(&_IPSBAR[0x00028C]))
#define MCF_UART2_UTB                 (*(hcc_reg8 *)(&_IPSBAR[0x00028C]))
#define MCF_UART2_UIPCR               (*(hcc_reg8 *)(&_IPSBAR[0x000290]))
#define MCF_UART2_UACR                (*(hcc_reg8 *)(&_IPSBAR[0x000290]))
#define MCF_UART2_UISR                (*(hcc_reg8 *)(&_IPSBAR[0x000294]))
#define MCF_UART2_UIMR                (*(hcc_reg8 *)(&_IPSBAR[0x000294]))
#define MCF_UART2_UBG1                (*(hcc_reg8 *)(&_IPSBAR[0x000298]))
#define MCF_UART2_UBG2                (*(hcc_reg8 *)(&_IPSBAR[0x00029C]))
#define MCF_UART2_UIP                 (*(hcc_reg8 *)(&_IPSBAR[0x0002B4]))
#define MCF_UART2_UOP1                (*(hcc_reg8 *)(&_IPSBAR[0x0002B8]))
#define MCF_UART2_UOP0                (*(hcc_reg8 *)(&_IPSBAR[0x0002BC]))
#define MCF_UART_UMR(x)               (*(hcc_reg8 *)(&_IPSBAR[0x000200+((x)*0x040)]))
#define MCF_UART_USR(x)               (*(hcc_reg8 *)(&_IPSBAR[0x000204+((x)*0x040)]))
#define MCF_UART_UCSR(x)              (*(hcc_reg8 *)(&_IPSBAR[0x000204+((x)*0x040)]))
#define MCF_UART_UCR(x)               (*(hcc_reg8 *)(&_IPSBAR[0x000208+((x)*0x040)]))
#define MCF_UART_URB(x)               (*(hcc_reg8 *)(&_IPSBAR[0x00020C+((x)*0x040)]))
#define MCF_UART_UTB(x)               (*(hcc_reg8 *)(&_IPSBAR[0x00020C+((x)*0x040)]))
#define MCF_UART_UIPCR(x)             (*(hcc_reg8 *)(&_IPSBAR[0x000210+((x)*0x040)]))
#define MCF_UART_UACR(x)              (*(hcc_reg8 *)(&_IPSBAR[0x000210+((x)*0x040)]))
#define MCF_UART_UISR(x)              (*(hcc_reg8 *)(&_IPSBAR[0x000214+((x)*0x040)]))
#define MCF_UART_UIMR(x)              (*(hcc_reg8 *)(&_IPSBAR[0x000214+((x)*0x040)]))
#define MCF_UART_UBG1(x)              (*(hcc_reg8 *)(&_IPSBAR[0x000218+((x)*0x040)]))
#define MCF_UART_UBG2(x)              (*(hcc_reg8 *)(&_IPSBAR[0x00021C+((x)*0x040)]))
#define MCF_UART_UIP(x)               (*(hcc_reg8 *)(&_IPSBAR[0x000234+((x)*0x040)]))
#define MCF_UART_UOP1(x)              (*(hcc_reg8 *)(&_IPSBAR[0x000238+((x)*0x040)]))
#define MCF_UART_UOP0(x)              (*(hcc_reg8 *)(&_IPSBAR[0x00023C+((x)*0x040)]))

/* Bit definitions and macros for MCF_UART_UMR */
#define MCF_UART_UMR_BC(x)            (((x)&0x03)<<0)
#define MCF_UART_UMR_PT               (0x04)
#define MCF_UART_UMR_PM(x)            (((x)&0x03)<<3)
#define MCF_UART_UMR_ERR              (0x20)
#define MCF_UART_UMR_RXIRQ            (0x40)
#define MCF_UART_UMR_RXRTS            (0x80)
#define MCF_UART_UMR_SB(x)            (((x)&0x0F)<<0)
#define MCF_UART_UMR_TXCTS            (0x10)
#define MCF_UART_UMR_TXRTS            (0x20)
#define MCF_UART_UMR_CM(x)            (((x)&0x03)<<6)
#define MCF_UART_UMR_PM_MULTI_ADDR    (0x1C)
#define MCF_UART_UMR_PM_MULTI_DATA    (0x18)
#define MCF_UART_UMR_PM_NONE          (0x10)
#define MCF_UART_UMR_PM_FORCE_HI      (0x0C)
#define MCF_UART_UMR_PM_FORCE_LO      (0x08)
#define MCF_UART_UMR_PM_ODD           (0x04)
#define MCF_UART_UMR_PM_EVEN          (0x00)
#define MCF_UART_UMR_BC_5             (0x00)
#define MCF_UART_UMR_BC_6             (0x01)
#define MCF_UART_UMR_BC_7             (0x02)
#define MCF_UART_UMR_BC_8             (0x03)
#define MCF_UART_UMR_CM_NORMAL        (0x00)
#define MCF_UART_UMR_CM_ECHO          (0x40)
#define MCF_UART_UMR_CM_LOCAL_LOOP    (0x80)
#define MCF_UART_UMR_CM_REMOTE_LOOP   (0xC0)
#define MCF_UART_UMR_SB_STOP_BITS_1   (0x07)
#define MCF_UART_UMR_SB_STOP_BITS_15  (0x08)
#define MCF_UART_UMR_SB_STOP_BITS_2   (0x0F)

/* Bit definitions and macros for MCF_UART_USR */
#define MCF_UART_USR_RXRDY            (0x01)
#define MCF_UART_USR_FFULL            (0x02)
#define MCF_UART_USR_TXRDY            (0x04)
#define MCF_UART_USR_TXEMP            (0x08)
#define MCF_UART_USR_OE               (0x10)
#define MCF_UART_USR_PE               (0x20)
#define MCF_UART_USR_FE               (0x40)
#define MCF_UART_USR_RB               (0x80)

/* Bit definitions and macros for MCF_UART_UCSR */
#define MCF_UART_UCSR_TCS(x)          (((x)&0x0F)<<0)
#define MCF_UART_UCSR_RCS(x)          (((x)&0x0F)<<4)
#define MCF_UART_UCSR_RCS_SYS_CLK     (0xD0)
#define MCF_UART_UCSR_RCS_CTM16       (0xE0)
#define MCF_UART_UCSR_RCS_CTM         (0xF0)
#define MCF_UART_UCSR_TCS_SYS_CLK     (0x0D)
#define MCF_UART_UCSR_TCS_CTM16       (0x0E)
#define MCF_UART_UCSR_TCS_CTM         (0x0F)

/* Bit definitions and macros for MCF_UART_UCR */
#define MCF_UART_UCR_RXC(x)           (((x)&0x03)<<0)
#define MCF_UART_UCR_TXC(x)           (((x)&0x03)<<2)
#define MCF_UART_UCR_MISC(x)          (((x)&0x07)<<4)
#define MCF_UART_UCR_NONE             (0x00)
#define MCF_UART_UCR_STOP_BREAK       (0x70)
#define MCF_UART_UCR_START_BREAK      (0x60)
#define MCF_UART_UCR_BKCHGINT         (0x50)
#define MCF_UART_UCR_RESET_ERROR      (0x40)
#define MCF_UART_UCR_RESET_TX         (0x30)
#define MCF_UART_UCR_RESET_RX         (0x20)
#define MCF_UART_UCR_RESET_MR         (0x10)
#define MCF_UART_UCR_TX_DISABLED      (0x08)
#define MCF_UART_UCR_TX_ENABLED       (0x04)
#define MCF_UART_UCR_RX_DISABLED      (0x02)
#define MCF_UART_UCR_RX_ENABLED       (0x01)

/* Bit definitions and macros for MCF_UART_UIPCR */
#define MCF_UART_UIPCR_CTS            (0x01)
#define MCF_UART_UIPCR_COS            (0x10)

/* Bit definitions and macros for MCF_UART_UACR */
#define MCF_UART_UACR_IEC             (0x01)

/* Bit definitions and macros for MCF_UART_UISR */
#define MCF_UART_UISR_TXRDY           (0x01)
#define MCF_UART_UISR_RXRDY_FU        (0x02)
#define MCF_UART_UISR_DB              (0x04)
#define MCF_UART_UISR_RXFTO           (0x08)
#define MCF_UART_UISR_TXFIFO          (0x10)
#define MCF_UART_UISR_RXFIFO          (0x20)
#define MCF_UART_UISR_COS             (0x80)

/* Bit definitions and macros for MCF_UART_UIMR */
#define MCF_UART_UIMR_TXRDY           (0x01)
#define MCF_UART_UIMR_RXRDY_FU        (0x02)
#define MCF_UART_UIMR_DB              (0x04)
#define MCF_UART_UIMR_COS             (0x80)

/* Bit definitions and macros for MCF_UART_UIP */
#define MCF_UART_UIP_CTS              (0x01)

/* Bit definitions and macros for MCF_UART_UOP1 */
#define MCF_UART_UOP1_RTS             (0x01)

/* Bit definitions and macros for MCF_UART_UOP0 */
#define MCF_UART_UOP0_RTS             (0x01)

/*********************************************************************
*
* ColdFire Integration Module (CIM)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_CIM_RCR             (*(hcc_reg8 *)(&_IPSBAR[0x110000]))
#define MCF_CIM_RSR             (*(hcc_reg8 *)(&_IPSBAR[0x110001]))
#define MCF_CIM_CCR             (*(hcc_reg16*)(&_IPSBAR[0x110004]))
#define MCF_CIM_LPCR            (*(hcc_reg8 *)(&_IPSBAR[0x110007]))
#define MCF_CIM_RCON            (*(hcc_reg16*)(&_IPSBAR[0x110008]))
#define MCF_CIM_CIR             (*(hcc_reg16*)(&_IPSBAR[0x11000A]))

/* Bit definitions and macros for MCF_CIM_RCR */
#define MCF_CIM_RCR_LVDE        (0x01)
#define MCF_CIM_RCR_LVDRE       (0x04)
#define MCF_CIM_RCR_LVDIE       (0x08)
#define MCF_CIM_RCR_LVDF        (0x10)
#define MCF_CIM_RCR_FRCRSTOUT   (0x40)
#define MCF_CIM_RCR_SOFTRST     (0x80)

/* Bit definitions and macros for MCF_CIM_RSR */
#define MCF_CIM_RSR_LOL         (0x01)
#define MCF_CIM_RSR_LOC         (0x02)
#define MCF_CIM_RSR_EXT         (0x04)
#define MCF_CIM_RSR_POR         (0x08)
#define MCF_CIM_RSR_WDR         (0x10)
#define MCF_CIM_RSR_SOFT        (0x20)
#define MCF_CIM_RSR_LVD         (0x40)

/* Bit definitions and macros for MCF_CIM_CCR */
#define MCF_CIM_CCR_LOAD        (0x8000)

/* Bit definitions and macros for MCF_CIM_LPCR */
#define MCF_CIM_LPCR_LVDSE      (0x02)
#define MCF_CIM_LPCR_STPMD(x)   (((x)&0x03)<<3)
#define MCF_CIM_LPCR_LPMD(x)    (((x)&0x03)<<6)
#define MCF_CIM_LPCR_LPMD_STOP  (0xC0)
#define MCF_CIM_LPCR_LPMD_WAIT  (0x80)
#define MCF_CIM_LPCR_LPMD_DOZE  (0x40)
#define MCF_CIM_LPCR_LPMD_RUN   (0x00)

/* Bit definitions and macros for MCF_CIM_RCON */
#define MCF_CIM_RCON_RLOAD      (0x0020)

/********************************************************************/





#endif
